/*===========================================================================*/
/*   (Eval/expand.scm)                                                       */
/*   Bigloo (3.8a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Mar 29 06:52:41 CEST 2012       */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q +rm -lib-dir /users/serrano/prgm/project/bigloo/lib/3.8a -mklib -cc gcc -fsharing -q -no-hello -copt -fPIC -unsafe -safee -O4 -c Eval/expand.scm -indent -o objs/obj_u/Eval/expand.c)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif
	static obj_t BGl_z62initialzd2expanderzb0zz__expandz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza31129ze3ze1zz__expandz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zz__expandz00 = BUNSPEC;
	static obj_t BGl_z62expandzd2oncezb0zz__expandz00(obj_t, obj_t);
	extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza31156ze3ze1zz__expandz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zz__expandz00();
	static obj_t BGl_applicationzd2evalzd2expanderz12z12zz__expandz00(obj_t,
		obj_t);
	static obj_t BGl_objectzd2initzd2zz__expandz00();
	static obj_t BGl_zc3exitza31215ze3z83zz__expandz00(obj_t, obj_t);
	extern obj_t BGl_valzd2fromzd2exitzf3zf3zz__bexitz00(obj_t);
	static obj_t BGl_z62applicationzd2evalzd2expanderz12z70zz__expandz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62expandz12z70zz__expandz00(obj_t, obj_t);
	extern obj_t BGl_parsezd2formalzd2identz00zz__evutilsz00(obj_t, obj_t);
	static obj_t BGl_z62z52withzd2lexicalze2zz__expandz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_appendzd221011zd2zz__expandz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zz__expandz00();
	static obj_t BGl_initialzd2expanderz12zc0zz__expandz00(obj_t, obj_t);
	extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62applicationzd2evalzd2expanderz62zz__expandz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62z52lexicalzd2stackze2zz__expandz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__macroz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evutilsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	BGL_EXPORTED_DECL obj_t BGl_expandz00zz__expandz00(obj_t);
	extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_z52withzd2lexicalz80zz__expandz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_z52lexicalzd2stackz80zz__expandz00();
	static obj_t BGl_importedzd2moduleszd2initz00zz__expandz00();
	extern obj_t BGl_getzd2evalzd2expanderz00zz__macroz00(obj_t);
	static obj_t BGl_z62identifierzd2evalzd2expanderz62zz__expandz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_expandz12z12zz__expandz00(obj_t);
	extern obj_t BGl_getzd2sourcezd2locationz00zz__readerz00(obj_t);
	static obj_t BGl_initialzd2expanderzd2zz__expandz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_expandzd2oncezd2zz__expandz00(obj_t);
	static obj_t BGl_z62initialzd2expanderz12za2zz__expandz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_loopz00zz__expandz00(obj_t, obj_t);
	static obj_t BGl_z62expandz62zz__expandz00(obj_t, obj_t);
	static obj_t BGl_initialzd2expanderzf2applicationz20zz__expandz00(obj_t,
		obj_t, obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_expandzd2oncezd2envz00zz__expandz00,
		BgL_bgl_za762expandza7d2once1541z00, BGl_z62expandzd2oncezb0zz__expandz00,
		0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string1531z00zz__expandz00,
		BgL_bgl_string1531za700za7za7_1542za7, "expand", 6);
	      DEFINE_STRING(BGl_string1532z00zz__expandz00,
		BgL_bgl_string1532za700za7za7_1543za7, "Illegal form", 12);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_applicationzd2evalzd2expanderzd2envzd2zz__expandz00,
		BgL_bgl_za762applicationza7d1544z00,
		BGl_z62applicationzd2evalzd2expanderz62zz__expandz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string1534z00zz__expandz00,
		BgL_bgl_string1534za700za7za7_1545za7, "application", 11);
	      DEFINE_STRING(BGl_string1535z00zz__expandz00,
		BgL_bgl_string1535za700za7za7_1546za7,
		"/tmp/bigloo/runtime/Eval/expand.scm", 35);
	      DEFINE_STRING(BGl_string1536z00zz__expandz00,
		BgL_bgl_string1536za700za7za7_1547za7, "&%with-lexical", 14);
	      DEFINE_STRING(BGl_string1537z00zz__expandz00,
		BgL_bgl_string1537za700za7za7_1548za7, "pair-nil", 8);
	      DEFINE_STRING(BGl_string1538z00zz__expandz00,
		BgL_bgl_string1538za700za7za7_1549za7, "procedure", 9);
	      DEFINE_STRING(BGl_string1539z00zz__expandz00,
		BgL_bgl_string1539za700za7za7_1550za7, "__expand", 8);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1530z00zz__expandz00,
		BgL_bgl_za762za7c3anonymousza71551za7,
		BGl_z62zc3anonymousza31129ze3ze1zz__expandz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1533z00zz__expandz00,
		BgL_bgl_za762za7c3anonymousza71552za7,
		BGl_z62zc3anonymousza31156ze3ze1zz__expandz00, 0L, BUNSPEC, 2);
	     
		DEFINE_STATIC_BGL_PROCEDURE(BGl_initialzd2expanderz12zd2envz12zz__expandz00,
		BgL_bgl_za762initialza7d2exp1553z00,
		BGl_z62initialzd2expanderz12za2zz__expandz00, 0L, BUNSPEC, 2);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_identifierzd2evalzd2expanderzd2envzd2zz__expandz00,
		BgL_bgl_za762identifierza7d21554z00,
		BGl_z62identifierzd2evalzd2expanderz62zz__expandz00, 0L, BUNSPEC, 2);
	     
		DEFINE_STATIC_BGL_PROCEDURE(BGl_initialzd2expanderzd2envz00zz__expandz00,
		BgL_bgl_za762initialza7d2exp1555z00,
		BGl_z62initialzd2expanderzb0zz__expandz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_expandzd2envzd2zz__expandz00,
		BgL_bgl_za762expandza762za7za7__1556z00, BGl_z62expandz62zz__expandz00, 0L,
		BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z52withzd2lexicalzd2envz52zz__expandz00,
		BgL_bgl_za762za752withza7d2lex1557za7,
		BGl_z62z52withzd2lexicalze2zz__expandz00, 0L, BUNSPEC, 4);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_expandz12zd2envzc0zz__expandz00,
		BgL_bgl_za762expandza712za770za71558z00, BGl_z62expandz12z70zz__expandz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_z52lexicalzd2stackzd2envz52zz__expandz00,
		BgL_bgl_za762za752lexicalza7d21559za7,
		BGl_z62z52lexicalzd2stackze2zz__expandz00, 0L, BUNSPEC, 0);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_applicationzd2evalzd2expanderz12zd2envzc0zz__expandz00,
		BgL_bgl_za762applicationza7d1560z00,
		BGl_z62applicationzd2evalzd2expanderz12z70zz__expandz00, 0L, BUNSPEC, 2);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long
		BgL_checksumz00_1387, char *BgL_fromz00_1388)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__expandz00))
				{
					BGl_requirezd2initializa7ationz75zz__expandz00 = BBOOL(((bool_t) 0));
					BGl_importedzd2moduleszd2initz00zz__expandz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zz__expandz00(obj_t BgL_l1z00_1, obj_t BgL_l2z00_2)
	{
		AN_OBJECT;
		{
			{
				obj_t BgL_headz00_598;

				BgL_headz00_598 = MAKE_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_977;
					obj_t BgL_tailz00_978;

					BgL_prevz00_977 = BgL_headz00_598;
					BgL_tailz00_978 = BgL_l1z00_1;
				BgL_loopz00_976:
					if (PAIRP(BgL_tailz00_978))
						{
							obj_t BgL_newzd2prevzd2_984;

							BgL_newzd2prevzd2_984 =
								MAKE_PAIR(CAR(BgL_tailz00_978), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_977, BgL_newzd2prevzd2_984);
							{
								obj_t BgL_tailz00_1400;
								obj_t BgL_prevz00_1399;

								BgL_prevz00_1399 = BgL_newzd2prevzd2_984;
								BgL_tailz00_1400 = CDR(BgL_tailz00_978);
								BgL_tailz00_978 = BgL_tailz00_1400;
								BgL_prevz00_977 = BgL_prevz00_1399;
								goto BgL_loopz00_976;
							}
						}
					else
						{
							BNIL;
						}
				}
				return CDR(BgL_headz00_598);
			}
		}
	}



/* expand */
	BGL_EXPORTED_DEF obj_t BGl_expandz00zz__expandz00(obj_t BgL_xz00_3)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 70 */
			return
				BGl_initialzd2expanderzf2applicationz20zz__expandz00(BgL_xz00_3,
				BGl_initialzd2expanderzd2envz00zz__expandz00,
				BGl_applicationzd2evalzd2expanderzd2envzd2zz__expandz00);
		}
	}



/* &expand */
	obj_t BGl_z62expandz62zz__expandz00(obj_t BgL_envz00_1330,
		obj_t BgL_xz00_1331)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 70 */
			return BGl_expandz00zz__expandz00(BgL_xz00_1331);
		}
	}



/* expand! */
	BGL_EXPORTED_DEF obj_t BGl_expandz12z12zz__expandz00(obj_t BgL_xz00_4)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 76 */
			return
				BGl_initialzd2expanderzf2applicationz20zz__expandz00(BgL_xz00_4,
				BGl_initialzd2expanderz12zd2envz12zz__expandz00,
				BGl_applicationzd2evalzd2expanderz12zd2envzc0zz__expandz00);
		}
	}



/* &expand! */
	obj_t BGl_z62expandz12z70zz__expandz00(obj_t BgL_envz00_1338,
		obj_t BgL_xz00_1339)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 76 */
			return BGl_expandz12z12zz__expandz00(BgL_xz00_1339);
		}
	}



/* expand-once */
	BGL_EXPORTED_DEF obj_t BGl_expandzd2oncezd2zz__expandz00(obj_t BgL_xz00_5)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 82 */
			return
				BGl_initialzd2expanderzf2applicationz20zz__expandz00(BgL_xz00_5,
				BGl_proc1530z00zz__expandz00,
				BGl_applicationzd2evalzd2expanderzd2envzd2zz__expandz00);
		}
	}



/* &expand-once */
	obj_t BGl_z62expandzd2oncezb0zz__expandz00(obj_t BgL_envz00_1347,
		obj_t BgL_xz00_1348)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 82 */
			return BGl_expandzd2oncezd2zz__expandz00(BgL_xz00_1348);
		}
	}



/* &<anonymous:1129> */
	obj_t BGl_z62zc3anonymousza31129ze3ze1zz__expandz00(obj_t BgL_envz00_1349,
		obj_t BgL_xz00_1350, obj_t BgL_ez00_1351)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 83 */
			return BgL_xz00_1350;
		}
	}



/* initial-expander */
	obj_t BGl_initialzd2expanderzd2zz__expandz00(obj_t BgL_xz00_6,
		obj_t BgL_ez00_7)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 88 */
			return
				BGl_initialzd2expanderzf2applicationz20zz__expandz00(BgL_xz00_6,
				BgL_ez00_7, BGl_applicationzd2evalzd2expanderzd2envzd2zz__expandz00);
		}
	}



/* &initial-expander */
	obj_t BGl_z62initialzd2expanderzb0zz__expandz00(obj_t BgL_envz00_1332,
		obj_t BgL_xz00_1333, obj_t BgL_ez00_1334)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 88 */
			return
				BGl_initialzd2expanderzd2zz__expandz00(BgL_xz00_1333, BgL_ez00_1334);
		}
	}



/* initial-expander! */
	obj_t BGl_initialzd2expanderz12zc0zz__expandz00(obj_t BgL_xz00_8,
		obj_t BgL_ez00_9)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 94 */
			return
				BGl_initialzd2expanderzf2applicationz20zz__expandz00(BgL_xz00_8,
				BgL_ez00_9, BGl_applicationzd2evalzd2expanderz12zd2envzc0zz__expandz00);
		}
	}



/* &initial-expander! */
	obj_t BGl_z62initialzd2expanderz12za2zz__expandz00(obj_t BgL_envz00_1340,
		obj_t BgL_xz00_1341, obj_t BgL_ez00_1342)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 94 */
			return
				BGl_initialzd2expanderz12zc0zz__expandz00(BgL_xz00_1341, BgL_ez00_1342);
		}
	}



/* initial-expander/application */
	obj_t BGl_initialzd2expanderzf2applicationz20zz__expandz00(obj_t BgL_xz00_10,
		obj_t BgL_ez00_11, obj_t BgL_aez00_12)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 100 */
			{	/* Eval/expand.scm 101 */
				obj_t BgL_e1z00_611;

				if (SYMBOLP(BgL_xz00_10))
					{	/* Eval/expand.scm 102 */
						BgL_e1z00_611 =
							BGl_identifierzd2evalzd2expanderzd2envzd2zz__expandz00;
					}
				else
					{	/* Eval/expand.scm 102 */
						if (NULLP(BgL_xz00_10))
							{	/* Eval/expand.scm 104 */
								BgL_e1z00_611 =
									BGl_errorz00zz__errorz00(BGl_string1531z00zz__expandz00,
									BGl_string1532z00zz__expandz00, BNIL);
							}
						else
							{	/* Eval/expand.scm 104 */
								if (PAIRP(BgL_xz00_10))
									{	/* Eval/expand.scm 108 */
										bool_t BgL_testz00_1420;

										{	/* Eval/expand.scm 108 */
											obj_t BgL_auxz00_1421;

											BgL_auxz00_1421 = CAR(BgL_xz00_10);
											BgL_testz00_1420 = SYMBOLP(BgL_auxz00_1421);
										}
										if (BgL_testz00_1420)
											{	/* Eval/expand.scm 110 */
												obj_t BgL_g1038z00_623;

												BgL_g1038z00_623 =
													BGl_getzd2evalzd2expanderz00zz__macroz00(CAR
													(BgL_xz00_10));
												if (CBOOL(BgL_g1038z00_623))
													{	/* Eval/expand.scm 110 */
														BgL_e1z00_611 = BgL_g1038z00_623;
													}
												else
													{	/* Eval/expand.scm 114 */
														obj_t BgL_locz00_626;

														BgL_locz00_626 =
															BGl_getzd2sourcezd2locationz00zz__readerz00
															(BgL_xz00_10);
														{	/* Eval/expand.scm 114 */
															obj_t BgL_idz00_627;

															BgL_idz00_627 =
																CAR(BGl_parsezd2formalzd2identz00zz__evutilsz00
																(CAR(BgL_xz00_10), BgL_locz00_626));
															{	/* Eval/expand.scm 115 */

																{	/* Eval/expand.scm 117 */
																	bool_t BgL_testz00_1432;

																	{	/* Eval/expand.scm 117 */
																		obj_t BgL_arg1145z00_632;

																		{	/* Eval/expand.scm 117 */
																			obj_t BgL_arg1147z00_633;

																			{	/* Eval/expand.scm 117 */
																				obj_t BgL_res1470z00_1012;

																				BgL_res1470z00_1012 =
																					BGL_LEXICAL_STACK();
																				BgL_arg1147z00_633 =
																					BgL_res1470z00_1012;
																			}
																			BgL_arg1145z00_632 =
																				BGl_assqz00zz__r4_pairs_and_lists_6_3z00
																				(BgL_idz00_627, BgL_arg1147z00_633);
																		}
																		BgL_testz00_1432 =
																			PAIRP(BgL_arg1145z00_632);
																	}
																	if (BgL_testz00_1432)
																		{	/* Eval/expand.scm 117 */
																			BgL_e1z00_611 = BgL_aez00_12;
																		}
																	else
																		{	/* Eval/expand.scm 119 */
																			obj_t BgL_g1040z00_629;

																			BgL_g1040z00_629 =
																				BGl_getzd2evalzd2expanderz00zz__macroz00
																				(BgL_idz00_627);
																			if (CBOOL(BgL_g1040z00_629))
																				{	/* Eval/expand.scm 119 */
																					BgL_e1z00_611 = BgL_g1040z00_629;
																				}
																			else
																				{	/* Eval/expand.scm 119 */
																					BgL_e1z00_611 = BgL_aez00_12;
																				}
																		}
																}
															}
														}
													}
											}
										else
											{	/* Eval/expand.scm 108 */
												BgL_e1z00_611 = BgL_aez00_12;
											}
									}
								else
									{	/* Eval/expand.scm 106 */
										BgL_e1z00_611 = BGl_proc1533z00zz__expandz00;
									}
							}
					}
				{	/* Eval/expand.scm 126 */
					obj_t BgL_newz00_612;

					BgL_newz00_612 =
						PROCEDURE_ENTRY(BgL_e1z00_611) (BgL_e1z00_611, BgL_xz00_10,
						BgL_ez00_11, BEOA);
					{	/* Eval/expand.scm 127 */
						bool_t BgL_testz00_1444;

						if (PAIRP(BgL_newz00_612))
							{	/* Eval/expand.scm 127 */
								bool_t BgL_testz00_1447;

								{	/* Eval/expand.scm 127 */
									bool_t BgL_res1473z00_1018;

									BgL_res1473z00_1018 = EXTENDED_PAIRP(BgL_newz00_612);
									BgL_testz00_1447 = BgL_res1473z00_1018;
								}
								if (BgL_testz00_1447)
									{	/* Eval/expand.scm 127 */
										BgL_testz00_1444 = ((bool_t) 0);
									}
								else
									{	/* Eval/expand.scm 127 */
										bool_t BgL_res1474z00_1020;

										BgL_res1474z00_1020 = EXTENDED_PAIRP(BgL_xz00_10);
										BgL_testz00_1444 = BgL_res1474z00_1020;
									}
							}
						else
							{	/* Eval/expand.scm 127 */
								BgL_testz00_1444 = ((bool_t) 0);
							}
						if (BgL_testz00_1444)
							{	/* Eval/expand.scm 128 */
								obj_t BgL_arg1131z00_614;
								obj_t BgL_arg1134z00_615;
								obj_t BgL_arg1137z00_616;

								BgL_arg1131z00_614 = CAR(BgL_newz00_612);
								BgL_arg1134z00_615 = CDR(BgL_newz00_612);
								BgL_arg1137z00_616 = CER(BgL_xz00_10);
								{	/* Eval/expand.scm 128 */
									obj_t BgL_res1475z00_1027;

									BgL_res1475z00_1027 =
										MAKE_EXTENDED_PAIR(BgL_arg1131z00_614, BgL_arg1134z00_615,
										BgL_arg1137z00_616);
									return BgL_res1475z00_1027;
								}
							}
						else
							{	/* Eval/expand.scm 127 */
								return BgL_newz00_612;
							}
					}
				}
			}
		}
	}



/* &<anonymous:1156> */
	obj_t BGl_z62zc3anonymousza31156ze3ze1zz__expandz00(obj_t BgL_envz00_1353,
		obj_t BgL_xz00_1354, obj_t BgL_ez00_1355)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 107 */
			return BgL_xz00_1354;
		}
	}



/* &identifier-eval-expander */
	obj_t BGl_z62identifierzd2evalzd2expanderz62zz__expandz00(obj_t
		BgL_envz00_1356, obj_t BgL_xz00_1357, obj_t BgL_ez00_1358)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 134 */
			return BgL_xz00_1357;
		}
	}



/* loop */
	obj_t BGl_loopz00zz__expandz00(obj_t BgL_ez00_1367, obj_t BgL_xz00_642)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 141 */
			if (NULLP(BgL_xz00_642))
				{	/* Eval/expand.scm 143 */
					return BNIL;
				}
			else
				{	/* Eval/expand.scm 143 */
					if (PAIRP(BgL_xz00_642))
						{	/* Eval/expand.scm 147 */
							bool_t BgL_testz00_1458;

							{	/* Eval/expand.scm 147 */
								bool_t BgL_res1478z00_1033;

								BgL_res1478z00_1033 = EXTENDED_PAIRP(BgL_xz00_642);
								BgL_testz00_1458 = BgL_res1478z00_1033;
							}
							if (BgL_testz00_1458)
								{	/* Eval/expand.scm 148 */
									obj_t BgL_arg1162z00_647;
									obj_t BgL_arg1163z00_648;
									obj_t BgL_arg1168z00_649;

									{	/* Eval/expand.scm 148 */
										obj_t BgL_arg1172z00_650;

										BgL_arg1172z00_650 = CAR(BgL_xz00_642);
										BgL_arg1162z00_647 =
											PROCEDURE_ENTRY(BgL_ez00_1367) (BgL_ez00_1367,
											BgL_arg1172z00_650, BgL_ez00_1367, BEOA);
									}
									BgL_arg1163z00_648 =
										BGl_loopz00zz__expandz00(BgL_ez00_1367, CDR(BgL_xz00_642));
									BgL_arg1168z00_649 = CER(BgL_xz00_642);
									{	/* Eval/expand.scm 148 */
										obj_t BgL_res1479z00_1040;

										BgL_res1479z00_1040 =
											MAKE_EXTENDED_PAIR(BgL_arg1162z00_647, BgL_arg1163z00_648,
											BgL_arg1168z00_649);
										return BgL_res1479z00_1040;
									}
								}
							else
								{	/* Eval/expand.scm 150 */
									obj_t BgL_arg1180z00_652;
									obj_t BgL_arg1186z00_653;

									{	/* Eval/expand.scm 150 */
										obj_t BgL_arg1188z00_654;

										BgL_arg1188z00_654 = CAR(BgL_xz00_642);
										BgL_arg1180z00_652 =
											PROCEDURE_ENTRY(BgL_ez00_1367) (BgL_ez00_1367,
											BgL_arg1188z00_654, BgL_ez00_1367, BEOA);
									}
									BgL_arg1186z00_653 =
										BGl_loopz00zz__expandz00(BgL_ez00_1367, CDR(BgL_xz00_642));
									return MAKE_PAIR(BgL_arg1180z00_652, BgL_arg1186z00_653);
								}
						}
					else
						{	/* Eval/expand.scm 145 */
							return
								BGl_errorz00zz__errorz00(BGl_string1534z00zz__expandz00,
								BGl_string1532z00zz__expandz00, BgL_xz00_642);
						}
				}
		}
	}



/* &application-eval-expander */
	obj_t BGl_z62applicationzd2evalzd2expanderz62zz__expandz00(obj_t
		BgL_envz00_1335, obj_t BgL_xz00_1336, obj_t BgL_ez00_1337)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 140 */
			return BGl_loopz00zz__expandz00(BgL_ez00_1337, BgL_xz00_1336);
		}
	}



/* application-eval-expander! */
	obj_t BGl_applicationzd2evalzd2expanderz12z12zz__expandz00(obj_t BgL_xz00_17,
		obj_t BgL_ez00_18)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 155 */
			{
				obj_t BgL_yz00_658;

				BgL_yz00_658 = BgL_xz00_17;
			BgL_zc3anonymousza31190ze3z83_659:
				if (NULLP(BgL_yz00_658))
					{	/* Eval/expand.scm 158 */
						return BgL_xz00_17;
					}
				else
					{	/* Eval/expand.scm 158 */
						if (PAIRP(BgL_yz00_658))
							{	/* Eval/expand.scm 160 */
								{	/* Eval/expand.scm 163 */
									obj_t BgL_arg1193z00_662;

									{	/* Eval/expand.scm 163 */
										obj_t BgL_arg1195z00_663;

										BgL_arg1195z00_663 = CAR(BgL_yz00_658);
										BgL_arg1193z00_662 =
											PROCEDURE_ENTRY(BgL_ez00_18) (BgL_ez00_18,
											BgL_arg1195z00_663, BgL_ez00_18, BEOA);
									}
									SET_CAR(BgL_yz00_658, BgL_arg1193z00_662);
								}
								{
									obj_t BgL_yz00_1492;

									BgL_yz00_1492 = CDR(BgL_yz00_658);
									BgL_yz00_658 = BgL_yz00_1492;
									goto BgL_zc3anonymousza31190ze3z83_659;
								}
							}
						else
							{	/* Eval/expand.scm 160 */
								return
									BGl_errorz00zz__errorz00(BGl_string1534z00zz__expandz00,
									BGl_string1532z00zz__expandz00, BgL_yz00_658);
							}
					}
			}
		}
	}



/* &application-eval-expander! */
	obj_t BGl_z62applicationzd2evalzd2expanderz12z70zz__expandz00(obj_t
		BgL_envz00_1343, obj_t BgL_xz00_1344, obj_t BgL_ez00_1345)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 155 */
			return
				BGl_applicationzd2evalzd2expanderz12z12zz__expandz00(BgL_xz00_1344,
				BgL_ez00_1345);
		}
	}



/* %lexical-stack */
	BGL_EXPORTED_DEF obj_t BGl_z52lexicalzd2stackz80zz__expandz00()
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 169 */
			return BGL_LEXICAL_STACK();
		}
	}



/* &%lexical-stack */
	obj_t BGl_z62z52lexicalzd2stackze2zz__expandz00(obj_t BgL_envz00_1359)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 169 */
			return BGL_LEXICAL_STACK();
		}
	}



/* %with-lexical */
	BGL_EXPORTED_DEF obj_t BGl_z52withzd2lexicalz80zz__expandz00(obj_t
		BgL_newz00_19, obj_t BgL_formz00_20, obj_t BgL_ez00_21, obj_t BgL_keyz00_22)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 175 */
			{	/* Eval/expand.scm 176 */
				obj_t BgL_oldzd2lexicalzd2stackz00_666;

				{	/* Eval/expand.scm 176 */
					obj_t BgL_res1482z00_1051;

					BgL_res1482z00_1051 = BGL_LEXICAL_STACK();
					BgL_oldzd2lexicalzd2stackz00_666 = BgL_res1482z00_1051;
				}
				{	/* Eval/expand.scm 177 */
					obj_t BgL_arg1197z00_667;

					{	/* Eval/expand.scm 177 */
						obj_t BgL_arg1199z00_668;

						if (NULLP(BgL_newz00_19))
							{	/* Eval/expand.scm 177 */
								BgL_arg1199z00_668 = BNIL;
							}
						else
							{	/* Eval/expand.scm 177 */
								obj_t BgL_head1073z00_671;

								{	/* Eval/expand.scm 177 */
									obj_t BgL_res1484z00_1056;

									BgL_res1484z00_1056 = MAKE_PAIR(BNIL, BNIL);
									BgL_head1073z00_671 = BgL_res1484z00_1056;
								}
								{
									obj_t BgL_l1071z00_1090;
									obj_t BgL_tail1074z00_1091;

									BgL_l1071z00_1090 = BgL_newz00_19;
									BgL_tail1074z00_1091 = BgL_head1073z00_671;
								BgL_zc3anonymousza31201ze3z83_1089:
									if (NULLP(BgL_l1071z00_1090))
										{	/* Eval/expand.scm 177 */
											BgL_arg1199z00_668 = CDR(BgL_head1073z00_671);
										}
									else
										{	/* Eval/expand.scm 177 */
											obj_t BgL_newtail1075z00_1098;

											{	/* Eval/expand.scm 177 */
												obj_t BgL_arg1208z00_1099;

												BgL_arg1208z00_1099 =
													MAKE_PAIR(CAR(BgL_l1071z00_1090), BgL_keyz00_22);
												{	/* Eval/expand.scm 177 */
													obj_t BgL_res1490z00_1108;

													BgL_res1490z00_1108 =
														MAKE_PAIR(BgL_arg1208z00_1099, BNIL);
													BgL_newtail1075z00_1098 = BgL_res1490z00_1108;
												}
											}
											SET_CDR(BgL_tail1074z00_1091, BgL_newtail1075z00_1098);
											{
												obj_t BgL_tail1074z00_1511;
												obj_t BgL_l1071z00_1509;

												BgL_l1071z00_1509 = CDR(BgL_l1071z00_1090);
												BgL_tail1074z00_1511 = BgL_newtail1075z00_1098;
												BgL_tail1074z00_1091 = BgL_tail1074z00_1511;
												BgL_l1071z00_1090 = BgL_l1071z00_1509;
												goto BgL_zc3anonymousza31201ze3z83_1089;
											}
										}
								}
							}
						BgL_arg1197z00_667 =
							BGl_appendzd221011zd2zz__expandz00(BgL_arg1199z00_668,
							BgL_oldzd2lexicalzd2stackz00_666);
					}
					BGL_LEXICAL_STACK_SET(BgL_arg1197z00_667);
					BUNSPEC;
				}
				{	/* Eval/expand.scm 179 */
					obj_t BgL_val1042z00_682;

					BgL_val1042z00_682 =
						BGl_zc3exitza31215ze3z83zz__expandz00(BgL_formz00_20, BgL_ez00_21);
					BGL_LEXICAL_STACK_SET(BgL_oldzd2lexicalzd2stackz00_666);
					BUNSPEC;
					if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
							(BgL_val1042z00_682)))
						{	/* Eval/expand.scm 181 */
							return
								BGl_unwindzd2untilz12zc0zz__bexitz00(CAR(BgL_val1042z00_682),
								CDR(BgL_val1042z00_682));
						}
					else
						{	/* Eval/expand.scm 181 */
							return BgL_val1042z00_682;
						}
				}
			}
		}
	}



/* <exit:1215> */
	obj_t BGl_zc3exitza31215ze3z83zz__expandz00(obj_t BgL_formz00_1366,
		obj_t BgL_ez00_1365)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 181 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1043z00_687;

			if (SET_EXIT(BgL_an_exit1043z00_687))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1043z00_687 = (void *) jmpbuf;
					{	/* Eval/expand.scm 181 */

						PUSH_EXIT(BgL_an_exit1043z00_687, ((long) 0));
						{	/* Eval/expand.scm 180 */
							obj_t BgL_val1044z00_688;

							BgL_val1044z00_688 =
								PROCEDURE_ENTRY(BgL_ez00_1365) (BgL_ez00_1365, BgL_formz00_1366,
								BgL_ez00_1365, BEOA);
							POP_EXIT();
							return BgL_val1044z00_688;
						}
					}
				}
		}
	}



/* &%with-lexical */
	obj_t BGl_z62z52withzd2lexicalze2zz__expandz00(obj_t BgL_envz00_1360,
		obj_t BgL_newz00_1361, obj_t BgL_formz00_1362, obj_t BgL_ez00_1363,
		obj_t BgL_keyz00_1364)
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 175 */
			{	/* Eval/expand.scm 176 */
				obj_t BgL_auxz00_1540;
				obj_t BgL_auxz00_1531;

				if (PROCEDUREP(BgL_ez00_1363))
					{	/* Eval/expand.scm 176 */
						BgL_auxz00_1540 = BgL_ez00_1363;
					}
				else
					{
						obj_t BgL_auxz00_1543;

						BgL_auxz00_1543 =
							BGl_typezd2errorzd2zz__errorz00(BGl_string1535z00zz__expandz00,
							BINT(((long) 6246)), BGl_string1536z00zz__expandz00,
							BGl_string1538z00zz__expandz00, BgL_ez00_1363);
						FAILURE(BgL_auxz00_1543, BFALSE, BFALSE);
					}
				{	/* Eval/expand.scm 176 */
					bool_t BgL_testz00_1532;

					if (PAIRP(BgL_newz00_1361))
						{	/* Eval/expand.scm 176 */
							BgL_testz00_1532 = ((bool_t) 1);
						}
					else
						{	/* Eval/expand.scm 176 */
							BgL_testz00_1532 = NULLP(BgL_newz00_1361);
						}
					if (BgL_testz00_1532)
						{	/* Eval/expand.scm 176 */
							BgL_auxz00_1531 = BgL_newz00_1361;
						}
					else
						{
							obj_t BgL_auxz00_1536;

							BgL_auxz00_1536 =
								BGl_typezd2errorzd2zz__errorz00(BGl_string1535z00zz__expandz00,
								BINT(((long) 6246)), BGl_string1536z00zz__expandz00,
								BGl_string1537z00zz__expandz00, BgL_newz00_1361);
							FAILURE(BgL_auxz00_1536, BFALSE, BFALSE);
				}}
				return
					BGl_z52withzd2lexicalz80zz__expandz00(BgL_auxz00_1531,
					BgL_formz00_1362, BgL_auxz00_1540, BgL_keyz00_1364);
			}
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__expandz00()
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 14 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__expandz00()
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 14 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__expandz00()
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 14 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__expandz00()
	{
		AN_OBJECT;
		{	/* Eval/expand.scm 14 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 278771016),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 373318193),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 162724851),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 159639574),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 438451175),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 441709255),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 426797061),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 220651073),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 220648206),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 359798486),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					249410258), BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					53386681), BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843), BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800), BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430), BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460263214),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 97251556),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					47127928), BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(((long) 415828492),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					317842797), BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 509771705),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 451655587),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)
					268291731), BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__evenvz00(((long) 335718988),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			BGl_modulezd2initializa7ationz75zz__evutilsz00(((long) 470356213),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
			return BGl_modulezd2initializa7ationz75zz__macroz00(((long) 261397491),
				BSTRING_TO_STRING(BGl_string1539z00zz__expandz00));
		}
	}

#ifdef __cplusplus
}
#endif
