/*===========================================================================*/
/*   (Unsafe/sha2.scm)                                                       */
/*   Bigloo (3.8a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Mar 29 06:52:41 CEST 2012       */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q +rm -lib-dir /users/serrano/prgm/project/bigloo/lib/3.8a -mklib -cc gcc -fsharing -q -no-hello -copt -fPIC -unsafe -safee -O4 -c Unsafe/sha2.scm -indent -o objs/obj_u/Unsafe/sha2.c)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif
	static unsigned long BGl_rotr32z00zz__sha2z00(unsigned long, int);
	BGL_EXPORTED_DECL obj_t BGl_sha256sumzd2filezd2zz__sha2z00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zz__sha2z00 = BUNSPEC;
	extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62sha256sumzd2stringzb0zz__sha2z00(obj_t, obj_t);
	static long BGl_z62fillzd2word32zd2stringz12z70zz__sha2z00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zz__sha2z00();
	static obj_t BGl_genericzd2initzd2zz__sha2z00();
	static obj_t BGl_objectzd2initzd2zz__sha2z00();
	extern obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_makezd2u32vectorzd2zz__srfi4z00(long, obj_t);
	extern obj_t BGl_valzd2fromzd2exitzf3zf3zz__bexitz00(obj_t);
	static obj_t BGl_methodzd2initzd2zz__sha2z00();
	static obj_t BGl_z62sha256sumz62zz__sha2z00(obj_t, obj_t);
	static obj_t BGl_statezd2ze3stringz31zz__sha2z00(obj_t);
	static obj_t BGl_z62sha256sumzd2portzb0zz__sha2z00(obj_t, obj_t);
	static unsigned long BGl_Sigma1zd2256zd2zz__sha2z00(unsigned long);
	static long BGl_z62fillzd2word32zd2portz12z70zz__sha2z00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t make_string(long, unsigned char);
	extern obj_t bgl_close_input_port(obj_t);
	static obj_t BGl_z62sha256sumzd2mmapzb0zz__sha2z00(obj_t, obj_t);
	extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_sha256sumz00zz__sha2z00(obj_t);
	static obj_t BGl_sha256zd2updatezd2zz__sha2z00(obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_hmaczd2sha256sumzd2stringz00zz__sha2z00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_sha256sumzd2portzd2zz__sha2z00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__sha2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__hmacz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_sha256sumzd2mmapzd2zz__sha2z00(obj_t);
	extern obj_t BGl_openzd2mmapzd2zz__mmapz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	static long BGl_z62fillzd2word32zd2mmapz12z70zz__sha2z00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(long,
		long);
	static obj_t BGl_z62hmaczd2sha256sumzd2stringz62zz__sha2z00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zz__sha2z00();
	extern obj_t BGl_hmaczd2stringzd2zz__hmacz00(obj_t, obj_t, obj_t);
	static obj_t BGl_sha256zd2initialzd2hashzd2valuezd2zz__sha2z00();
	static obj_t BGl_zc3exitza31662ze3z83zz__sha2z00(obj_t);
	static obj_t BGl_z62sha256sumzd2filezb0zz__sha2z00(obj_t, obj_t);
	extern obj_t blit_string(obj_t, long, obj_t, long, long);
	static obj_t BGl_u32zd2fillz12zc0zz__sha2z00(obj_t, long, unsigned long);
	static obj_t BGl_K256z00zz__sha2z00 = BUNSPEC;
	static obj_t BGl_sha256zd2internalzd2transformz00zz__sha2z00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_sha256sumzd2stringzd2zz__sha2z00(obj_t);
	extern obj_t BGl_readzd2bytezd2zz__r4_input_6_10_2z00(obj_t);
	static obj_t BGl_zc3exitza31658ze3z83zz__sha2z00(obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_sha256sumzd2stringzd2envz00zz__sha2z00,
		BgL_bgl_za762sha256sumza7d2s2516z00,
		BGl_z62sha256sumzd2stringzb0zz__sha2z00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2503z00zz__sha2z00,
		BgL_bgl_string2503za700za7za7_2517za7,
		"/tmp/bigloo/runtime/Unsafe/sha2.scm", 35);
	      DEFINE_STRING(BGl_string2504z00zz__sha2z00,
		BgL_bgl_string2504za700za7za7_2518za7, "&sha256sum-mmap", 15);
	      DEFINE_STRING(BGl_string2505z00zz__sha2z00,
		BgL_bgl_string2505za700za7za7_2519za7, "mmap", 4);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sha256sumzd2envzd2zz__sha2z00,
		BgL_bgl_za762sha256sumza762za72520za7, BGl_z62sha256sumz62zz__sha2z00, 0L,
		BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2507z00zz__sha2z00,
		BgL_bgl_string2507za700za7za7_2521za7, "&sha256sum-string", 17);
	      DEFINE_STRING(BGl_string2508z00zz__sha2z00,
		BgL_bgl_string2508za700za7za7_2522za7, "bstring", 7);
	      DEFINE_STRING(BGl_string2509z00zz__sha2z00,
		BgL_bgl_string2509za700za7za7_2523za7, "&sha256sum-port", 15);
	      DEFINE_BGL_L_PROCEDURE(BGl_proc2502z00zz__sha2z00,
		BgL_bgl_za762fillza7d2word322524z00,
		BGl_z62fillzd2word32zd2mmapz12z70zz__sha2z00);
	      DEFINE_STRING(BGl_string2510z00zz__sha2z00,
		BgL_bgl_string2510za700za7za7_2525za7, "input-port", 10);
	      DEFINE_STRING(BGl_string2511z00zz__sha2z00,
		BgL_bgl_string2511za700za7za7_2526za7, "&sha256sum-file", 15);
	      DEFINE_STRING(BGl_string2512z00zz__sha2z00,
		BgL_bgl_string2512za700za7za7_2527za7, "sha256sum", 9);
	      DEFINE_BGL_L_PROCEDURE(BGl_proc2506z00zz__sha2z00,
		BgL_bgl_za762fillza7d2word322528z00,
		BGl_z62fillzd2word32zd2stringz12z70zz__sha2z00);
	      DEFINE_STRING(BGl_string2513z00zz__sha2z00,
		BgL_bgl_string2513za700za7za7_2529za7, "Illegal argument", 16);
	      DEFINE_STRING(BGl_string2514z00zz__sha2z00,
		BgL_bgl_string2514za700za7za7_2530za7, "&hmac-sha256sum-string", 22);
	      DEFINE_STRING(BGl_string2515z00zz__sha2z00,
		BgL_bgl_string2515za700za7za7_2531za7, "__sha2", 6);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sha256sumzd2mmapzd2envz00zz__sha2z00,
		BgL_bgl_za762sha256sumza7d2m2532z00, BGl_z62sha256sumzd2mmapzb0zz__sha2z00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sha256sumzd2filezd2envz00zz__sha2z00,
		BgL_bgl_za762sha256sumza7d2f2533z00, BGl_z62sha256sumzd2filezb0zz__sha2z00,
		0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_hmaczd2sha256sumzd2stringzd2envzd2zz__sha2z00,
		BgL_bgl_za762hmacza7d2sha2562534z00,
		BGl_z62hmaczd2sha256sumzd2stringz62zz__sha2z00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sha256sumzd2portzd2envz00zz__sha2z00,
		BgL_bgl_za762sha256sumza7d2p2535z00, BGl_z62sha256sumzd2portzb0zz__sha2z00,
		0L, BUNSPEC, 1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__sha2z00(long
		BgL_checksumz00_3610, char *BgL_fromz00_3611)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__sha2z00))
				{
					BGl_requirezd2initializa7ationz75zz__sha2z00 = BBOOL(((bool_t) 0));
					BGl_importedzd2moduleszd2initz00zz__sha2z00();
					BGl_toplevelzd2initzd2zz__sha2z00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zz__sha2z00()
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 50 */
			{	/* Unsafe/sha2.scm 206 */
				obj_t BgL_vz00_770;

				{	/* Llib/srfi4.scm 236 */

					BgL_vz00_770 =
						BGl_makezd2u32vectorzd2zz__srfi4z00(((long) 64), BINT(((long) 0)));
				}
				{	/* Unsafe/sha2.scm 207 */
					long BgL_arg1137z00_771;

					BgL_arg1137z00_771 =
						((((long) 17034) << (int) (((long) 16))) | ((long) 12184));
					{	/* Unsafe/sha2.scm 207 */
						unsigned long BgL_auxz00_3622;

						BgL_auxz00_3622 = (unsigned long) (BgL_arg1137z00_771);
						BGL_U32VSET(BgL_vz00_770, ((long) 0), BgL_auxz00_3622);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 208 */
					long BgL_arg1139z00_773;

					BgL_arg1139z00_773 =
						((((long) 28983) << (int) (((long) 16))) | ((long) 17553));
					{	/* Unsafe/sha2.scm 208 */
						unsigned long BgL_auxz00_3628;

						BgL_auxz00_3628 = (unsigned long) (BgL_arg1139z00_773);
						BGL_U32VSET(BgL_vz00_770, ((long) 1), BgL_auxz00_3628);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 209 */
					long BgL_arg1144z00_775;

					BgL_arg1144z00_775 =
						((((long) 46528) << (int) (((long) 16))) | ((long) 64463));
					{	/* Unsafe/sha2.scm 209 */
						unsigned long BgL_auxz00_3634;

						BgL_auxz00_3634 = (unsigned long) (BgL_arg1144z00_775);
						BGL_U32VSET(BgL_vz00_770, ((long) 2), BgL_auxz00_3634);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 210 */
					long BgL_arg1147z00_777;

					BgL_arg1147z00_777 =
						((((long) 59829) << (int) (((long) 16))) | ((long) 56229));
					{	/* Unsafe/sha2.scm 210 */
						unsigned long BgL_auxz00_3640;

						BgL_auxz00_3640 = (unsigned long) (BgL_arg1147z00_777);
						BGL_U32VSET(BgL_vz00_770, ((long) 3), BgL_auxz00_3640);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 211 */
					long BgL_arg1151z00_779;

					BgL_arg1151z00_779 =
						((((long) 14678) << (int) (((long) 16))) | ((long) 49755));
					{	/* Unsafe/sha2.scm 211 */
						unsigned long BgL_auxz00_3646;

						BgL_auxz00_3646 = (unsigned long) (BgL_arg1151z00_779);
						BGL_U32VSET(BgL_vz00_770, ((long) 4), BgL_auxz00_3646);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 212 */
					long BgL_arg1155z00_781;

					BgL_arg1155z00_781 =
						((((long) 23025) << (int) (((long) 16))) | ((long) 4593));
					{	/* Unsafe/sha2.scm 212 */
						unsigned long BgL_auxz00_3652;

						BgL_auxz00_3652 = (unsigned long) (BgL_arg1155z00_781);
						BGL_U32VSET(BgL_vz00_770, ((long) 5), BgL_auxz00_3652);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 213 */
					long BgL_arg1162z00_783;

					BgL_arg1162z00_783 =
						((((long) 37439) << (int) (((long) 16))) | ((long) 33444));
					{	/* Unsafe/sha2.scm 213 */
						unsigned long BgL_auxz00_3658;

						BgL_auxz00_3658 = (unsigned long) (BgL_arg1162z00_783);
						BGL_U32VSET(BgL_vz00_770, ((long) 6), BgL_auxz00_3658);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 214 */
					long BgL_arg1168z00_785;

					BgL_arg1168z00_785 =
						((((long) 43804) << (int) (((long) 16))) | ((long) 24277));
					{	/* Unsafe/sha2.scm 214 */
						unsigned long BgL_auxz00_3664;

						BgL_auxz00_3664 = (unsigned long) (BgL_arg1168z00_785);
						BGL_U32VSET(BgL_vz00_770, ((long) 7), BgL_auxz00_3664);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 215 */
					long BgL_arg1178z00_787;

					BgL_arg1178z00_787 =
						((((long) 55303) << (int) (((long) 16))) | ((long) 43672));
					{	/* Unsafe/sha2.scm 215 */
						unsigned long BgL_auxz00_3670;

						BgL_auxz00_3670 = (unsigned long) (BgL_arg1178z00_787);
						BGL_U32VSET(BgL_vz00_770, ((long) 8), BgL_auxz00_3670);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 216 */
					long BgL_arg1186z00_789;

					BgL_arg1186z00_789 =
						((((long) 4739) << (int) (((long) 16))) | ((long) 23297));
					{	/* Unsafe/sha2.scm 216 */
						unsigned long BgL_auxz00_3676;

						BgL_auxz00_3676 = (unsigned long) (BgL_arg1186z00_789);
						BGL_U32VSET(BgL_vz00_770, ((long) 9), BgL_auxz00_3676);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 217 */
					long BgL_arg1189z00_791;

					BgL_arg1189z00_791 =
						((((long) 9265) << (int) (((long) 16))) | ((long) 34238));
					{	/* Unsafe/sha2.scm 217 */
						unsigned long BgL_auxz00_3682;

						BgL_auxz00_3682 = (unsigned long) (BgL_arg1189z00_791);
						BGL_U32VSET(BgL_vz00_770, ((long) 10), BgL_auxz00_3682);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 218 */
					long BgL_arg1195z00_793;

					BgL_arg1195z00_793 =
						((((long) 21772) << (int) (((long) 16))) | ((long) 32195));
					{	/* Unsafe/sha2.scm 218 */
						unsigned long BgL_auxz00_3688;

						BgL_auxz00_3688 = (unsigned long) (BgL_arg1195z00_793);
						BGL_U32VSET(BgL_vz00_770, ((long) 11), BgL_auxz00_3688);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 219 */
					long BgL_arg1197z00_795;

					BgL_arg1197z00_795 =
						((((long) 29374) << (int) (((long) 16))) | ((long) 23924));
					{	/* Unsafe/sha2.scm 219 */
						unsigned long BgL_auxz00_3694;

						BgL_auxz00_3694 = (unsigned long) (BgL_arg1197z00_795);
						BGL_U32VSET(BgL_vz00_770, ((long) 12), BgL_auxz00_3694);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 220 */
					long BgL_arg1200z00_797;

					BgL_arg1200z00_797 =
						((((long) 32990) << (int) (((long) 16))) | ((long) 45566));
					{	/* Unsafe/sha2.scm 220 */
						unsigned long BgL_auxz00_3700;

						BgL_auxz00_3700 = (unsigned long) (BgL_arg1200z00_797);
						BGL_U32VSET(BgL_vz00_770, ((long) 13), BgL_auxz00_3700);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 221 */
					long BgL_arg1202z00_799;

					BgL_arg1202z00_799 =
						((((long) 39900) << (int) (((long) 16))) | ((long) 1703));
					{	/* Unsafe/sha2.scm 221 */
						unsigned long BgL_auxz00_3706;

						BgL_auxz00_3706 = (unsigned long) (BgL_arg1202z00_799);
						BGL_U32VSET(BgL_vz00_770, ((long) 14), BgL_auxz00_3706);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 222 */
					long BgL_arg1208z00_801;

					BgL_arg1208z00_801 =
						((((long) 49563) << (int) (((long) 16))) | ((long) 61812));
					{	/* Unsafe/sha2.scm 222 */
						unsigned long BgL_auxz00_3712;

						BgL_auxz00_3712 = (unsigned long) (BgL_arg1208z00_801);
						BGL_U32VSET(BgL_vz00_770, ((long) 15), BgL_auxz00_3712);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 223 */
					long BgL_arg1210z00_803;

					BgL_arg1210z00_803 =
						((((long) 58523) << (int) (((long) 16))) | ((long) 27073));
					{	/* Unsafe/sha2.scm 223 */
						unsigned long BgL_auxz00_3718;

						BgL_auxz00_3718 = (unsigned long) (BgL_arg1210z00_803);
						BGL_U32VSET(BgL_vz00_770, ((long) 16), BgL_auxz00_3718);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 224 */
					long BgL_arg1217z00_805;

					BgL_arg1217z00_805 =
						((((long) 61374) << (int) (((long) 16))) | ((long) 18310));
					{	/* Unsafe/sha2.scm 224 */
						unsigned long BgL_auxz00_3724;

						BgL_auxz00_3724 = (unsigned long) (BgL_arg1217z00_805);
						BGL_U32VSET(BgL_vz00_770, ((long) 17), BgL_auxz00_3724);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 225 */
					long BgL_arg1220z00_807;

					BgL_arg1220z00_807 =
						((((long) 4033) << (int) (((long) 16))) | ((long) 40390));
					{	/* Unsafe/sha2.scm 225 */
						unsigned long BgL_auxz00_3730;

						BgL_auxz00_3730 = (unsigned long) (BgL_arg1220z00_807);
						BGL_U32VSET(BgL_vz00_770, ((long) 18), BgL_auxz00_3730);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 226 */
					long BgL_arg1222z00_809;

					BgL_arg1222z00_809 =
						((((long) 9228) << (int) (((long) 16))) | ((long) 41420));
					{	/* Unsafe/sha2.scm 226 */
						unsigned long BgL_auxz00_3736;

						BgL_auxz00_3736 = (unsigned long) (BgL_arg1222z00_809);
						BGL_U32VSET(BgL_vz00_770, ((long) 19), BgL_auxz00_3736);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 227 */
					long BgL_arg1227z00_811;

					BgL_arg1227z00_811 =
						((((long) 11753) << (int) (((long) 16))) | ((long) 11375));
					{	/* Unsafe/sha2.scm 227 */
						unsigned long BgL_auxz00_3742;

						BgL_auxz00_3742 = (unsigned long) (BgL_arg1227z00_811);
						BGL_U32VSET(BgL_vz00_770, ((long) 20), BgL_auxz00_3742);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 228 */
					long BgL_arg1234z00_813;

					BgL_arg1234z00_813 =
						((((long) 19060) << (int) (((long) 16))) | ((long) 33962));
					{	/* Unsafe/sha2.scm 228 */
						unsigned long BgL_auxz00_3748;

						BgL_auxz00_3748 = (unsigned long) (BgL_arg1234z00_813);
						BGL_U32VSET(BgL_vz00_770, ((long) 21), BgL_auxz00_3748);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 229 */
					long BgL_arg1243z00_815;

					BgL_arg1243z00_815 =
						((((long) 23728) << (int) (((long) 16))) | ((long) 43484));
					{	/* Unsafe/sha2.scm 229 */
						unsigned long BgL_auxz00_3754;

						BgL_auxz00_3754 = (unsigned long) (BgL_arg1243z00_815);
						BGL_U32VSET(BgL_vz00_770, ((long) 22), BgL_auxz00_3754);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 230 */
					long BgL_arg1249z00_817;

					BgL_arg1249z00_817 =
						((((long) 30457) << (int) (((long) 16))) | ((long) 35034));
					{	/* Unsafe/sha2.scm 230 */
						unsigned long BgL_auxz00_3760;

						BgL_auxz00_3760 = (unsigned long) (BgL_arg1249z00_817);
						BGL_U32VSET(BgL_vz00_770, ((long) 23), BgL_auxz00_3760);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 231 */
					long BgL_arg1251z00_819;

					BgL_arg1251z00_819 =
						((((long) 38974) << (int) (((long) 16))) | ((long) 20818));
					{	/* Unsafe/sha2.scm 231 */
						unsigned long BgL_auxz00_3766;

						BgL_auxz00_3766 = (unsigned long) (BgL_arg1251z00_819);
						BGL_U32VSET(BgL_vz00_770, ((long) 24), BgL_auxz00_3766);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 232 */
					long BgL_arg1253z00_821;

					BgL_arg1253z00_821 =
						((((long) 43057) << (int) (((long) 16))) | ((long) 50797));
					{	/* Unsafe/sha2.scm 232 */
						unsigned long BgL_auxz00_3772;

						BgL_auxz00_3772 = (unsigned long) (BgL_arg1253z00_821);
						BGL_U32VSET(BgL_vz00_770, ((long) 25), BgL_auxz00_3772);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 233 */
					long BgL_arg1256z00_823;

					BgL_arg1256z00_823 =
						((((long) 45059) << (int) (((long) 16))) | ((long) 10184));
					{	/* Unsafe/sha2.scm 233 */
						unsigned long BgL_auxz00_3778;

						BgL_auxz00_3778 = (unsigned long) (BgL_arg1256z00_823);
						BGL_U32VSET(BgL_vz00_770, ((long) 26), BgL_auxz00_3778);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 234 */
					long BgL_arg1258z00_825;

					BgL_arg1258z00_825 =
						((((long) 48985) << (int) (((long) 16))) | ((long) 32711));
					{	/* Unsafe/sha2.scm 234 */
						unsigned long BgL_auxz00_3784;

						BgL_auxz00_3784 = (unsigned long) (BgL_arg1258z00_825);
						BGL_U32VSET(BgL_vz00_770, ((long) 27), BgL_auxz00_3784);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 235 */
					long BgL_arg1263z00_827;

					BgL_arg1263z00_827 =
						((((long) 50912) << (int) (((long) 16))) | ((long) 3059));
					{	/* Unsafe/sha2.scm 235 */
						unsigned long BgL_auxz00_3790;

						BgL_auxz00_3790 = (unsigned long) (BgL_arg1263z00_827);
						BGL_U32VSET(BgL_vz00_770, ((long) 28), BgL_auxz00_3790);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 236 */
					long BgL_arg1265z00_829;

					BgL_arg1265z00_829 =
						((((long) 54695) << (int) (((long) 16))) | ((long) 37191));
					{	/* Unsafe/sha2.scm 236 */
						unsigned long BgL_auxz00_3796;

						BgL_auxz00_3796 = (unsigned long) (BgL_arg1265z00_829);
						BGL_U32VSET(BgL_vz00_770, ((long) 29), BgL_auxz00_3796);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 237 */
					long BgL_arg1269z00_831;

					BgL_arg1269z00_831 =
						((((long) 1738) << (int) (((long) 16))) | ((long) 25425));
					{	/* Unsafe/sha2.scm 237 */
						unsigned long BgL_auxz00_3802;

						BgL_auxz00_3802 = (unsigned long) (BgL_arg1269z00_831);
						BGL_U32VSET(BgL_vz00_770, ((long) 30), BgL_auxz00_3802);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 238 */
					long BgL_arg1271z00_833;

					BgL_arg1271z00_833 =
						((((long) 5161) << (int) (((long) 16))) | ((long) 10599));
					{	/* Unsafe/sha2.scm 238 */
						unsigned long BgL_auxz00_3808;

						BgL_auxz00_3808 = (unsigned long) (BgL_arg1271z00_833);
						BGL_U32VSET(BgL_vz00_770, ((long) 31), BgL_auxz00_3808);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 239 */
					long BgL_arg1273z00_835;

					BgL_arg1273z00_835 =
						((((long) 10167) << (int) (((long) 16))) | ((long) 2693));
					{	/* Unsafe/sha2.scm 239 */
						unsigned long BgL_auxz00_3814;

						BgL_auxz00_3814 = (unsigned long) (BgL_arg1273z00_835);
						BGL_U32VSET(BgL_vz00_770, ((long) 32), BgL_auxz00_3814);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 240 */
					long BgL_arg1280z00_837;

					BgL_arg1280z00_837 =
						((((long) 11803) << (int) (((long) 16))) | ((long) 8504));
					{	/* Unsafe/sha2.scm 240 */
						unsigned long BgL_auxz00_3820;

						BgL_auxz00_3820 = (unsigned long) (BgL_arg1280z00_837);
						BGL_U32VSET(BgL_vz00_770, ((long) 33), BgL_auxz00_3820);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 241 */
					long BgL_arg1289z00_839;

					BgL_arg1289z00_839 =
						((((long) 19756) << (int) (((long) 16))) | ((long) 28156));
					{	/* Unsafe/sha2.scm 241 */
						unsigned long BgL_auxz00_3826;

						BgL_auxz00_3826 = (unsigned long) (BgL_arg1289z00_839);
						BGL_U32VSET(BgL_vz00_770, ((long) 34), BgL_auxz00_3826);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 242 */
					long BgL_arg1292z00_841;

					BgL_arg1292z00_841 =
						((((long) 21304) << (int) (((long) 16))) | ((long) 3347));
					{	/* Unsafe/sha2.scm 242 */
						unsigned long BgL_auxz00_3832;

						BgL_auxz00_3832 = (unsigned long) (BgL_arg1292z00_841);
						BGL_U32VSET(BgL_vz00_770, ((long) 35), BgL_auxz00_3832);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 243 */
					long BgL_arg1296z00_843;

					BgL_arg1296z00_843 =
						((((long) 25866) << (int) (((long) 16))) | ((long) 29524));
					{	/* Unsafe/sha2.scm 243 */
						unsigned long BgL_auxz00_3838;

						BgL_auxz00_3838 = (unsigned long) (BgL_arg1296z00_843);
						BGL_U32VSET(BgL_vz00_770, ((long) 36), BgL_auxz00_3838);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 244 */
					long BgL_arg1301z00_845;

					BgL_arg1301z00_845 =
						((((long) 30314) << (int) (((long) 16))) | ((long) 2747));
					{	/* Unsafe/sha2.scm 244 */
						unsigned long BgL_auxz00_3844;

						BgL_auxz00_3844 = (unsigned long) (BgL_arg1301z00_845);
						BGL_U32VSET(BgL_vz00_770, ((long) 37), BgL_auxz00_3844);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 245 */
					long BgL_arg1304z00_847;

					BgL_arg1304z00_847 =
						((((long) 33218) << (int) (((long) 16))) | ((long) 51502));
					{	/* Unsafe/sha2.scm 245 */
						unsigned long BgL_auxz00_3850;

						BgL_auxz00_3850 = (unsigned long) (BgL_arg1304z00_847);
						BGL_U32VSET(BgL_vz00_770, ((long) 38), BgL_auxz00_3850);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 246 */
					long BgL_arg1306z00_849;

					BgL_arg1306z00_849 =
						((((long) 37490) << (int) (((long) 16))) | ((long) 11397));
					{	/* Unsafe/sha2.scm 246 */
						unsigned long BgL_auxz00_3856;

						BgL_auxz00_3856 = (unsigned long) (BgL_arg1306z00_849);
						BGL_U32VSET(BgL_vz00_770, ((long) 39), BgL_auxz00_3856);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 247 */
					long BgL_arg1308z00_851;

					BgL_arg1308z00_851 =
						((((long) 41663) << (int) (((long) 16))) | ((long) 59553));
					{	/* Unsafe/sha2.scm 247 */
						unsigned long BgL_auxz00_3862;

						BgL_auxz00_3862 = (unsigned long) (BgL_arg1308z00_851);
						BGL_U32VSET(BgL_vz00_770, ((long) 40), BgL_auxz00_3862);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 248 */
					long BgL_arg1310z00_853;

					BgL_arg1310z00_853 =
						((((long) 43034) << (int) (((long) 16))) | ((long) 26187));
					{	/* Unsafe/sha2.scm 248 */
						unsigned long BgL_auxz00_3868;

						BgL_auxz00_3868 = (unsigned long) (BgL_arg1310z00_853);
						BGL_U32VSET(BgL_vz00_770, ((long) 41), BgL_auxz00_3868);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 249 */
					long BgL_arg1312z00_855;

					BgL_arg1312z00_855 =
						((((long) 49739) << (int) (((long) 16))) | ((long) 35696));
					{	/* Unsafe/sha2.scm 249 */
						unsigned long BgL_auxz00_3874;

						BgL_auxz00_3874 = (unsigned long) (BgL_arg1312z00_855);
						BGL_U32VSET(BgL_vz00_770, ((long) 42), BgL_auxz00_3874);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 250 */
					long BgL_arg1314z00_857;

					BgL_arg1314z00_857 =
						((((long) 51052) << (int) (((long) 16))) | ((long) 20899));
					{	/* Unsafe/sha2.scm 250 */
						unsigned long BgL_auxz00_3880;

						BgL_auxz00_3880 = (unsigned long) (BgL_arg1314z00_857);
						BGL_U32VSET(BgL_vz00_770, ((long) 43), BgL_auxz00_3880);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 251 */
					long BgL_arg1316z00_859;

					BgL_arg1316z00_859 =
						((((long) 53650) << (int) (((long) 16))) | ((long) 59417));
					{	/* Unsafe/sha2.scm 251 */
						unsigned long BgL_auxz00_3886;

						BgL_auxz00_3886 = (unsigned long) (BgL_arg1316z00_859);
						BGL_U32VSET(BgL_vz00_770, ((long) 44), BgL_auxz00_3886);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 252 */
					long BgL_arg1318z00_861;

					BgL_arg1318z00_861 =
						((((long) 54937) << (int) (((long) 16))) | ((long) 1572));
					{	/* Unsafe/sha2.scm 252 */
						unsigned long BgL_auxz00_3892;

						BgL_auxz00_3892 = (unsigned long) (BgL_arg1318z00_861);
						BGL_U32VSET(BgL_vz00_770, ((long) 45), BgL_auxz00_3892);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 253 */
					long BgL_arg1320z00_863;

					BgL_arg1320z00_863 =
						((((long) 62478) << (int) (((long) 16))) | ((long) 13701));
					{	/* Unsafe/sha2.scm 253 */
						unsigned long BgL_auxz00_3898;

						BgL_auxz00_3898 = (unsigned long) (BgL_arg1320z00_863);
						BGL_U32VSET(BgL_vz00_770, ((long) 46), BgL_auxz00_3898);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 254 */
					long BgL_arg1322z00_865;

					BgL_arg1322z00_865 =
						((((long) 4202) << (int) (((long) 16))) | ((long) 41072));
					{	/* Unsafe/sha2.scm 254 */
						unsigned long BgL_auxz00_3904;

						BgL_auxz00_3904 = (unsigned long) (BgL_arg1322z00_865);
						BGL_U32VSET(BgL_vz00_770, ((long) 47), BgL_auxz00_3904);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 255 */
					long BgL_arg1324z00_867;

					BgL_arg1324z00_867 =
						((((long) 6564) << (int) (((long) 16))) | ((long) 49430));
					{	/* Unsafe/sha2.scm 255 */
						unsigned long BgL_auxz00_3910;

						BgL_auxz00_3910 = (unsigned long) (BgL_arg1324z00_867);
						BGL_U32VSET(BgL_vz00_770, ((long) 48), BgL_auxz00_3910);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 256 */
					long BgL_arg1326z00_869;

					BgL_arg1326z00_869 =
						((((long) 7735) << (int) (((long) 16))) | ((long) 27656));
					{	/* Unsafe/sha2.scm 256 */
						unsigned long BgL_auxz00_3916;

						BgL_auxz00_3916 = (unsigned long) (BgL_arg1326z00_869);
						BGL_U32VSET(BgL_vz00_770, ((long) 49), BgL_auxz00_3916);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 257 */
					long BgL_arg1328z00_871;

					BgL_arg1328z00_871 =
						((((long) 10056) << (int) (((long) 16))) | ((long) 30540));
					{	/* Unsafe/sha2.scm 257 */
						unsigned long BgL_auxz00_3922;

						BgL_auxz00_3922 = (unsigned long) (BgL_arg1328z00_871);
						BGL_U32VSET(BgL_vz00_770, ((long) 50), BgL_auxz00_3922);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 258 */
					long BgL_arg1331z00_873;

					BgL_arg1331z00_873 =
						((((long) 13488) << (int) (((long) 16))) | ((long) 48309));
					{	/* Unsafe/sha2.scm 258 */
						unsigned long BgL_auxz00_3928;

						BgL_auxz00_3928 = (unsigned long) (BgL_arg1331z00_873);
						BGL_U32VSET(BgL_vz00_770, ((long) 51), BgL_auxz00_3928);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 259 */
					long BgL_arg1335z00_875;

					BgL_arg1335z00_875 =
						((((long) 14620) << (int) (((long) 16))) | ((long) 3251));
					{	/* Unsafe/sha2.scm 259 */
						unsigned long BgL_auxz00_3934;

						BgL_auxz00_3934 = (unsigned long) (BgL_arg1335z00_875);
						BGL_U32VSET(BgL_vz00_770, ((long) 52), BgL_auxz00_3934);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 260 */
					long BgL_arg1337z00_877;

					BgL_arg1337z00_877 =
						((((long) 20184) << (int) (((long) 16))) | ((long) 43594));
					{	/* Unsafe/sha2.scm 260 */
						unsigned long BgL_auxz00_3940;

						BgL_auxz00_3940 = (unsigned long) (BgL_arg1337z00_877);
						BGL_U32VSET(BgL_vz00_770, ((long) 53), BgL_auxz00_3940);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 261 */
					long BgL_arg1340z00_879;

					BgL_arg1340z00_879 =
						((((long) 23452) << (int) (((long) 16))) | ((long) 51791));
					{	/* Unsafe/sha2.scm 261 */
						unsigned long BgL_auxz00_3946;

						BgL_auxz00_3946 = (unsigned long) (BgL_arg1340z00_879);
						BGL_U32VSET(BgL_vz00_770, ((long) 54), BgL_auxz00_3946);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 262 */
					long BgL_arg1342z00_881;

					BgL_arg1342z00_881 =
						((((long) 26670) << (int) (((long) 16))) | ((long) 28659));
					{	/* Unsafe/sha2.scm 262 */
						unsigned long BgL_auxz00_3952;

						BgL_auxz00_3952 = (unsigned long) (BgL_arg1342z00_881);
						BGL_U32VSET(BgL_vz00_770, ((long) 55), BgL_auxz00_3952);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 263 */
					long BgL_arg1344z00_883;

					BgL_arg1344z00_883 =
						((((long) 29839) << (int) (((long) 16))) | ((long) 33518));
					{	/* Unsafe/sha2.scm 263 */
						unsigned long BgL_auxz00_3958;

						BgL_auxz00_3958 = (unsigned long) (BgL_arg1344z00_883);
						BGL_U32VSET(BgL_vz00_770, ((long) 56), BgL_auxz00_3958);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 264 */
					long BgL_arg1346z00_885;

					BgL_arg1346z00_885 =
						((((long) 30885) << (int) (((long) 16))) | ((long) 25455));
					{	/* Unsafe/sha2.scm 264 */
						unsigned long BgL_auxz00_3964;

						BgL_auxz00_3964 = (unsigned long) (BgL_arg1346z00_885);
						BGL_U32VSET(BgL_vz00_770, ((long) 57), BgL_auxz00_3964);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 265 */
					long BgL_arg1348z00_887;

					BgL_arg1348z00_887 =
						((((long) 33992) << (int) (((long) 16))) | ((long) 30740));
					{	/* Unsafe/sha2.scm 265 */
						unsigned long BgL_auxz00_3970;

						BgL_auxz00_3970 = (unsigned long) (BgL_arg1348z00_887);
						BGL_U32VSET(BgL_vz00_770, ((long) 58), BgL_auxz00_3970);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 266 */
					long BgL_arg1350z00_889;

					BgL_arg1350z00_889 =
						((((long) 36039) << (int) (((long) 16))) | ((long) 520));
					{	/* Unsafe/sha2.scm 266 */
						unsigned long BgL_auxz00_3976;

						BgL_auxz00_3976 = (unsigned long) (BgL_arg1350z00_889);
						BGL_U32VSET(BgL_vz00_770, ((long) 59), BgL_auxz00_3976);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 267 */
					long BgL_arg1352z00_891;

					BgL_arg1352z00_891 =
						((((long) 37054) << (int) (((long) 16))) | ((long) 65530));
					{	/* Unsafe/sha2.scm 267 */
						unsigned long BgL_auxz00_3982;

						BgL_auxz00_3982 = (unsigned long) (BgL_arg1352z00_891);
						BGL_U32VSET(BgL_vz00_770, ((long) 60), BgL_auxz00_3982);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 268 */
					long BgL_arg1354z00_893;

					BgL_arg1354z00_893 =
						((((long) 42064) << (int) (((long) 16))) | ((long) 27883));
					{	/* Unsafe/sha2.scm 268 */
						unsigned long BgL_auxz00_3988;

						BgL_auxz00_3988 = (unsigned long) (BgL_arg1354z00_893);
						BGL_U32VSET(BgL_vz00_770, ((long) 61), BgL_auxz00_3988);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 269 */
					long BgL_arg1356z00_895;

					BgL_arg1356z00_895 =
						((((long) 48889) << (int) (((long) 16))) | ((long) 41975));
					{	/* Unsafe/sha2.scm 269 */
						unsigned long BgL_auxz00_3994;

						BgL_auxz00_3994 = (unsigned long) (BgL_arg1356z00_895);
						BGL_U32VSET(BgL_vz00_770, ((long) 62), BgL_auxz00_3994);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 270 */
					long BgL_arg1358z00_897;

					BgL_arg1358z00_897 =
						((((long) 50801) << (int) (((long) 16))) | ((long) 30962));
					{	/* Unsafe/sha2.scm 270 */
						unsigned long BgL_auxz00_4000;

						BgL_auxz00_4000 = (unsigned long) (BgL_arg1358z00_897);
						BGL_U32VSET(BgL_vz00_770, ((long) 63), BgL_auxz00_4000);
					} BUNSPEC;
				}
				return (BGl_K256z00zz__sha2z00 = BgL_vz00_770, BUNSPEC);
			}
		}
	}



/* rotr32 */
	unsigned long BGl_rotr32z00zz__sha2z00(unsigned long BgL_xz00_5,
		int BgL_nz00_6)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 151 */
			return
				(unsigned long) (
				((long) (
						(BgL_xz00_5 >>
							(int) (
								(long) (BgL_nz00_6)))) |
					((long) (BgL_xz00_5) <<
						(int) ((((long) 32) - (long) (BgL_nz00_6))))));
		}
	}



/* u32-fill! */
	obj_t BGl_u32zd2fillz12zc0zz__sha2z00(obj_t BgL_strz00_7,
		long BgL_offsetz00_8, unsigned long BgL_wz00_9)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 157 */
			{	/* Unsafe/sha2.scm 158 */
				obj_t BgL_s1z00_920;

				BgL_s1z00_920 =
					BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(
					(long) ((BgL_wz00_9 >> (int) (((long) 16)))), ((long) 16));
				{	/* Unsafe/sha2.scm 158 */
					long BgL_l1z00_921;

					BgL_l1z00_921 = STRING_LENGTH(BgL_s1z00_920);
					{	/* Unsafe/sha2.scm 159 */
						obj_t BgL_s2z00_922;

						BgL_s2z00_922 =
							BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(
							((long) (BgL_wz00_9) &
								((((long) 1) <<
										(int) (((long) 16))) - ((long) 1))), ((long) 16));
						{	/* Unsafe/sha2.scm 160 */
							long BgL_l2z00_923;

							BgL_l2z00_923 = STRING_LENGTH(BgL_s2z00_922);
							{	/* Unsafe/sha2.scm 161 */

								blit_string(BgL_s1z00_920, ((long) 0), BgL_strz00_7,
									(BgL_offsetz00_8 +
										(((long) 4) - BgL_l1z00_921)), BgL_l1z00_921);
								return
									blit_string(BgL_s2z00_922, ((long) 0), BgL_strz00_7,
									(BgL_offsetz00_8 +
										(((long) 4) +
											(((long) 4) - BgL_l2z00_923))), BgL_l2z00_923);
		}}}}}}
	}



/* state->string */
	obj_t BGl_statezd2ze3stringz31zz__sha2z00(obj_t BgL_statez00_10)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 168 */
			{	/* Unsafe/sha2.scm 169 */
				obj_t BgL_rz00_933;

				BgL_rz00_933 = make_string(((long) 64), ((unsigned char) '0'));
				{	/* Unsafe/sha2.scm 170 */
					unsigned long BgL_arg1383z00_934;

					BgL_arg1383z00_934 = BGL_U32VREF(BgL_statez00_10, ((long) 0));
					BGl_u32zd2fillz12zc0zz__sha2z00(BgL_rz00_933, ((long) 0),
						BgL_arg1383z00_934);
				}
				{	/* Unsafe/sha2.scm 171 */
					unsigned long BgL_arg1384z00_935;

					BgL_arg1384z00_935 = BGL_U32VREF(BgL_statez00_10, ((long) 1));
					BGl_u32zd2fillz12zc0zz__sha2z00(BgL_rz00_933, ((long) 8),
						BgL_arg1384z00_935);
				}
				{	/* Unsafe/sha2.scm 172 */
					unsigned long BgL_arg1385z00_936;

					BgL_arg1385z00_936 = BGL_U32VREF(BgL_statez00_10, ((long) 2));
					BGl_u32zd2fillz12zc0zz__sha2z00(BgL_rz00_933, ((long) 16),
						BgL_arg1385z00_936);
				}
				{	/* Unsafe/sha2.scm 173 */
					unsigned long BgL_arg1386z00_937;

					BgL_arg1386z00_937 = BGL_U32VREF(BgL_statez00_10, ((long) 3));
					BGl_u32zd2fillz12zc0zz__sha2z00(BgL_rz00_933, ((long) 24),
						BgL_arg1386z00_937);
				}
				{	/* Unsafe/sha2.scm 174 */
					unsigned long BgL_arg1387z00_938;

					BgL_arg1387z00_938 = BGL_U32VREF(BgL_statez00_10, ((long) 4));
					BGl_u32zd2fillz12zc0zz__sha2z00(BgL_rz00_933, ((long) 32),
						BgL_arg1387z00_938);
				}
				{	/* Unsafe/sha2.scm 175 */
					unsigned long BgL_arg1388z00_939;

					BgL_arg1388z00_939 = BGL_U32VREF(BgL_statez00_10, ((long) 5));
					BGl_u32zd2fillz12zc0zz__sha2z00(BgL_rz00_933, ((long) 40),
						BgL_arg1388z00_939);
				}
				{	/* Unsafe/sha2.scm 176 */
					unsigned long BgL_arg1389z00_940;

					BgL_arg1389z00_940 = BGL_U32VREF(BgL_statez00_10, ((long) 6));
					BGl_u32zd2fillz12zc0zz__sha2z00(BgL_rz00_933, ((long) 48),
						BgL_arg1389z00_940);
				}
				{	/* Unsafe/sha2.scm 177 */
					unsigned long BgL_arg1390z00_941;

					BgL_arg1390z00_941 = BGL_U32VREF(BgL_statez00_10, ((long) 7));
					BGl_u32zd2fillz12zc0zz__sha2z00(BgL_rz00_933, ((long) 56),
						BgL_arg1390z00_941);
				}
				return BgL_rz00_933;
			}
		}
	}



/* sha256-initial-hash-value */
	obj_t BGl_sha256zd2initialzd2hashzd2valuezd2zz__sha2z00()
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 276 */
			{	/* Unsafe/sha2.scm 277 */
				obj_t BgL_vz00_942;

				{	/* Llib/srfi4.scm 236 */

					BgL_vz00_942 =
						BGl_makezd2u32vectorzd2zz__srfi4z00(((long) 8), BINT(((long) 0)));
				}
				{	/* Unsafe/sha2.scm 278 */
					long BgL_arg1391z00_943;

					BgL_arg1391z00_943 =
						((((long) 27145) << (int) (((long) 16))) | ((long) 58983));
					{	/* Unsafe/sha2.scm 278 */
						unsigned long BgL_auxz00_4055;

						BgL_auxz00_4055 = (unsigned long) (BgL_arg1391z00_943);
						BGL_U32VSET(BgL_vz00_942, ((long) 0), BgL_auxz00_4055);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 279 */
					long BgL_arg1396z00_945;

					BgL_arg1396z00_945 =
						((((long) 47975) << (int) (((long) 16))) | ((long) 44677));
					{	/* Unsafe/sha2.scm 279 */
						unsigned long BgL_auxz00_4061;

						BgL_auxz00_4061 = (unsigned long) (BgL_arg1396z00_945);
						BGL_U32VSET(BgL_vz00_942, ((long) 1), BgL_auxz00_4061);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 280 */
					long BgL_arg1398z00_947;

					BgL_arg1398z00_947 =
						((((long) 15470) << (int) (((long) 16))) | ((long) 62322));
					{	/* Unsafe/sha2.scm 280 */
						unsigned long BgL_auxz00_4067;

						BgL_auxz00_4067 = (unsigned long) (BgL_arg1398z00_947);
						BGL_U32VSET(BgL_vz00_942, ((long) 2), BgL_auxz00_4067);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 281 */
					long BgL_arg1400z00_949;

					BgL_arg1400z00_949 =
						((((long) 42319) << (int) (((long) 16))) | ((long) 62778));
					{	/* Unsafe/sha2.scm 281 */
						unsigned long BgL_auxz00_4073;

						BgL_auxz00_4073 = (unsigned long) (BgL_arg1400z00_949);
						BGL_U32VSET(BgL_vz00_942, ((long) 3), BgL_auxz00_4073);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 282 */
					long BgL_arg1402z00_951;

					BgL_arg1402z00_951 =
						((((long) 20750) << (int) (((long) 16))) | ((long) 21119));
					{	/* Unsafe/sha2.scm 282 */
						unsigned long BgL_auxz00_4079;

						BgL_auxz00_4079 = (unsigned long) (BgL_arg1402z00_951);
						BGL_U32VSET(BgL_vz00_942, ((long) 4), BgL_auxz00_4079);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 283 */
					long BgL_arg1404z00_953;

					BgL_arg1404z00_953 =
						((((long) 39685) << (int) (((long) 16))) | ((long) 26764));
					{	/* Unsafe/sha2.scm 283 */
						unsigned long BgL_auxz00_4085;

						BgL_auxz00_4085 = (unsigned long) (BgL_arg1404z00_953);
						BGL_U32VSET(BgL_vz00_942, ((long) 5), BgL_auxz00_4085);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 284 */
					long BgL_arg1406z00_955;

					BgL_arg1406z00_955 =
						((((long) 8067) << (int) (((long) 16))) | ((long) 55723));
					{	/* Unsafe/sha2.scm 284 */
						unsigned long BgL_auxz00_4091;

						BgL_auxz00_4091 = (unsigned long) (BgL_arg1406z00_955);
						BGL_U32VSET(BgL_vz00_942, ((long) 6), BgL_auxz00_4091);
					} BUNSPEC;
				}
				{	/* Unsafe/sha2.scm 285 */
					long BgL_arg1408z00_957;

					BgL_arg1408z00_957 =
						((((long) 23520) << (int) (((long) 16))) | ((long) 52505));
					{	/* Unsafe/sha2.scm 285 */
						unsigned long BgL_auxz00_4097;

						BgL_auxz00_4097 = (unsigned long) (BgL_arg1408z00_957);
						BGL_U32VSET(BgL_vz00_942, ((long) 7), BgL_auxz00_4097);
					} BUNSPEC;
				}
				return BgL_vz00_942;
			}
		}
	}



/* Sigma1-256 */
	unsigned long BGl_Sigma1zd2256zd2zz__sha2z00(unsigned long BgL_xz00_19)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 315 */
			{	/* Unsafe/sha2.scm 316 */
				long BgL_auxz00_4100;

				{	/* Unsafe/sha2.scm 316 */
					long BgL_auxz00_4116;
					long BgL_auxz00_4101;

					{	/* Unsafe/sha2.scm 316 */
						long BgL_auxz00_4132;
						long BgL_auxz00_4117;

						{	/* Unsafe/sha2.scm 316 */
							unsigned long BgL_auxz00_4133;

							{	/* Unsafe/sha2.scm 316 */
								int BgL_nz00_2538;

								BgL_nz00_2538 = (int) (((long) 25));
								BgL_auxz00_4133 =
									(unsigned long) (
									((long) (
											(BgL_xz00_19 >>
												(int) (
													(long) (BgL_nz00_2538)))) |
										((long) (BgL_xz00_19) <<
											(int) ((((long) 32) - (long) (BgL_nz00_2538))))));
							}
							BgL_auxz00_4132 = (long) (BgL_auxz00_4133);
						}
						{	/* Unsafe/sha2.scm 316 */
							unsigned long BgL_auxz00_4118;

							{	/* Unsafe/sha2.scm 316 */
								int BgL_nz00_2520;

								BgL_nz00_2520 = (int) (((long) 11));
								BgL_auxz00_4118 =
									(unsigned long) (
									((long) (
											(BgL_xz00_19 >>
												(int) (
													(long) (BgL_nz00_2520)))) |
										((long) (BgL_xz00_19) <<
											(int) ((((long) 32) - (long) (BgL_nz00_2520))))));
							}
							BgL_auxz00_4117 = (long) (BgL_auxz00_4118);
						}
						BgL_auxz00_4116 = (BgL_auxz00_4117 ^ BgL_auxz00_4132);
					}
					{	/* Unsafe/sha2.scm 316 */
						unsigned long BgL_auxz00_4102;

						{	/* Unsafe/sha2.scm 316 */
							int BgL_nz00_2502;

							BgL_nz00_2502 = (int) (((long) 6));
							BgL_auxz00_4102 =
								(unsigned long) (
								((long) (
										(BgL_xz00_19 >>
											(int) (
												(long) (BgL_nz00_2502)))) |
									((long) (BgL_xz00_19) <<
										(int) ((((long) 32) - (long) (BgL_nz00_2502))))));
						}
						BgL_auxz00_4101 = (long) (BgL_auxz00_4102);
					}
					BgL_auxz00_4100 = (BgL_auxz00_4101 ^ BgL_auxz00_4116);
				}
				return (unsigned long) (BgL_auxz00_4100);
		}}
	}



/* sha256-internal-transform */
	obj_t BGl_sha256zd2internalzd2transformz00zz__sha2z00(obj_t BgL_statez00_29,
		obj_t BgL_bufferz00_30)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 339 */
			{
				obj_t BgL_statez00_1079;
				unsigned long BgL_az00_1080;
				unsigned long BgL_bz00_1081;
				unsigned long BgL_cz00_1082;
				unsigned long BgL_dz00_1083;
				unsigned long BgL_ez00_1084;
				unsigned long BgL_fz00_1085;
				unsigned long BgL_gz00_1086;
				unsigned long BgL_hz00_1087;

				{	/* Unsafe/sha2.scm 376 */
					unsigned long BgL_g1050z00_988;
					unsigned long BgL_g1051z00_989;
					unsigned long BgL_g1052z00_990;
					unsigned long BgL_g1053z00_991;
					unsigned long BgL_g1054z00_992;
					unsigned long BgL_g1055z00_993;
					unsigned long BgL_g1056z00_994;
					unsigned long BgL_g1057z00_995;

					{	/* Unsafe/sha2.scm 376 */
						unsigned long BgL_res2279z00_2667;

						BgL_res2279z00_2667 = BGL_U32VREF(BgL_statez00_29, ((long) 0));
						BgL_g1050z00_988 = BgL_res2279z00_2667;
					}
					{	/* Unsafe/sha2.scm 377 */
						unsigned long BgL_res2280z00_2669;

						BgL_res2280z00_2669 = BGL_U32VREF(BgL_statez00_29, ((long) 1));
						BgL_g1051z00_989 = BgL_res2280z00_2669;
					}
					{	/* Unsafe/sha2.scm 378 */
						unsigned long BgL_res2281z00_2671;

						BgL_res2281z00_2671 = BGL_U32VREF(BgL_statez00_29, ((long) 2));
						BgL_g1052z00_990 = BgL_res2281z00_2671;
					}
					{	/* Unsafe/sha2.scm 379 */
						unsigned long BgL_res2282z00_2673;

						BgL_res2282z00_2673 = BGL_U32VREF(BgL_statez00_29, ((long) 3));
						BgL_g1053z00_991 = BgL_res2282z00_2673;
					}
					{	/* Unsafe/sha2.scm 380 */
						unsigned long BgL_res2283z00_2675;

						BgL_res2283z00_2675 = BGL_U32VREF(BgL_statez00_29, ((long) 4));
						BgL_g1054z00_992 = BgL_res2283z00_2675;
					}
					{	/* Unsafe/sha2.scm 381 */
						unsigned long BgL_res2284z00_2677;

						BgL_res2284z00_2677 = BGL_U32VREF(BgL_statez00_29, ((long) 5));
						BgL_g1055z00_993 = BgL_res2284z00_2677;
					}
					{	/* Unsafe/sha2.scm 382 */
						unsigned long BgL_res2285z00_2679;

						BgL_res2285z00_2679 = BGL_U32VREF(BgL_statez00_29, ((long) 6));
						BgL_g1056z00_994 = BgL_res2285z00_2679;
					}
					{	/* Unsafe/sha2.scm 383 */
						unsigned long BgL_res2286z00_2681;

						BgL_res2286z00_2681 = BGL_U32VREF(BgL_statez00_29, ((long) 7));
						BgL_g1057z00_995 = BgL_res2286z00_2681;
					}
					{
						unsigned long BgL_az00_997;
						unsigned long BgL_bz00_998;
						unsigned long BgL_cz00_999;
						unsigned long BgL_dz00_1000;
						unsigned long BgL_ez00_1001;
						unsigned long BgL_fz00_1002;
						unsigned long BgL_gz00_1003;
						unsigned long BgL_hz00_1004;
						long BgL_jz00_1005;

						BgL_az00_997 = BgL_g1050z00_988;
						BgL_bz00_998 = BgL_g1051z00_989;
						BgL_cz00_999 = BgL_g1052z00_990;
						BgL_dz00_1000 = BgL_g1053z00_991;
						BgL_ez00_1001 = BgL_g1054z00_992;
						BgL_fz00_1002 = BgL_g1055z00_993;
						BgL_gz00_1003 = BgL_g1056z00_994;
						BgL_hz00_1004 = BgL_g1057z00_995;
						BgL_jz00_1005 = ((long) 0);
					BgL_zc3anonymousza31438ze3z83_1006:
						if ((BgL_jz00_1005 < ((long) 16)))
							{	/* Unsafe/sha2.scm 387 */
								unsigned long BgL_wz00_1008;

								BgL_wz00_1008 = BGL_U32VREF(BgL_bufferz00_30, BgL_jz00_1005);
								{	/* Unsafe/sha2.scm 387 */
									unsigned long BgL_t1z00_1009;

									{	/* Unsafe/sha2.scm 388 */
										unsigned long BgL_arg1474z00_2691;

										{	/* Unsafe/sha2.scm 388 */
											unsigned long BgL_arg1475z00_2692;
											unsigned long BgL_arg1477z00_2693;

											BgL_arg1475z00_2692 =
												BGl_Sigma1zd2256zd2zz__sha2z00(BgL_ez00_1001);
											{	/* Unsafe/sha2.scm 388 */
												unsigned long BgL_arg1478z00_2694;
												unsigned long BgL_arg1480z00_2695;

												BgL_arg1478z00_2694 =
													(unsigned long) (
													(((long) (BgL_ez00_1001) &
															(long) (BgL_fz00_1002)) ^
														(~((long) (BgL_ez00_1001)) &
															(long) (BgL_gz00_1003))));
												{	/* Unsafe/sha2.scm 388 */
													unsigned long BgL_arg1481z00_2696;

													BgL_arg1481z00_2696 =
														BGL_U32VREF(BGl_K256z00zz__sha2z00, BgL_jz00_1005);
													{	/* Unsafe/sha2.scm 388 */

														BgL_arg1480z00_2695 =
															(unsigned long) (
															((long) (
																	(unsigned long) (
																		((long) (
																				(unsigned long) (
																					(((long) 65535) &
																						((long) (
																								(BgL_arg1481z00_2696 >>
																									(int) (((long) 16)))) +
																							(long) (
																								(BgL_wz00_1008 >>
																									(int) (((long) 16)))))))) <<
																			(int) (((long) 16))))) +
																(long) (
																	(unsigned long) (
																		((long) (
																				(unsigned long) (
																					((long) (BgL_arg1481z00_2696) &
																						((long) 65535)))) +
																			(long) ((unsigned
																					long) (((long) (BgL_wz00_1008) &
																						((long) 65535)))))))));
												}}
												{	/* Unsafe/sha2.scm 388 */

													BgL_arg1477z00_2693 =
														(unsigned long) (
														((long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				(((long) 65535) &
																					((long) (
																							(BgL_arg1478z00_2694 >>
																								(int) (((long) 16)))) +
																						(long) (
																							(BgL_arg1480z00_2695 >>
																								(int) (((long) 16)))))))) <<
																		(int) (((long) 16))))) +
															(long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				((long) (BgL_arg1478z00_2694) & ((long)
																						65535)))) +
																		(long) ((unsigned
																				long) (((long) (BgL_arg1480z00_2695) &
																					((long) 65535)))))))));
											}}
											{	/* Unsafe/sha2.scm 388 */

												BgL_arg1474z00_2691 =
													(unsigned long) (
													((long) (
															(unsigned long) (
																((long) (
																		(unsigned long) (
																			(((long) 65535) &
																				((long) (
																						(BgL_arg1475z00_2692 >>
																							(int) (((long) 16)))) +
																					(long) (
																						(BgL_arg1477z00_2693 >>
																							(int) (((long) 16)))))))) <<
																	(int) (((long) 16))))) +
														(long) (
															(unsigned long) (
																((long) (
																		(unsigned long) (
																			((long) (BgL_arg1475z00_2692) & ((long)
																					65535)))) +
																	(long) ((unsigned
																			long) (((long) (BgL_arg1477z00_2693) &
																				((long) 65535)))))))));
										}}
										{	/* Unsafe/sha2.scm 388 */

											BgL_t1z00_1009 =
												(unsigned long) (
												((long) (
														(unsigned long) (
															((long) (
																	(unsigned long) (
																		(((long) 65535) &
																			((long) (
																					(BgL_hz00_1004 >>
																						(int) (((long) 16)))) +
																				(long) (
																					(BgL_arg1474z00_2691 >>
																						(int) (((long) 16)))))))) <<
																(int) (((long) 16))))) +
													(long) (
														(unsigned long) (
															((long) (
																	(unsigned long) (
																		((long) (BgL_hz00_1004) & ((long) 65535))))
																+
																(long) ((unsigned
																		long) (((long) (BgL_arg1474z00_2691) &
																			((long) 65535)))))))));
									}}
									{	/* Unsafe/sha2.scm 388 */
										unsigned long BgL_t2z00_1010;

										{	/* Unsafe/sha2.scm 389 */
											unsigned long BgL_n1z00_3584;
											unsigned long BgL_n2z00_3585;

											BgL_n1z00_3584 =
												(unsigned long) (
												((long) (BGl_rotr32z00zz__sha2z00(BgL_az00_997,
															(int) (((long) 2)))) ^
													((long) (BGl_rotr32z00zz__sha2z00(BgL_az00_997,
																(int) (((long) 13)))) ^
														(long) (BGl_rotr32z00zz__sha2z00(BgL_az00_997,
																(int) (((long) 22)))))));
											BgL_n2z00_3585 =
												(unsigned long) (
												(((long) (BgL_az00_997) &
														(long) (BgL_bz00_998)) ^
													(((long) (BgL_az00_997) &
															(long) (BgL_cz00_999)) ^
														((long) (BgL_bz00_998) & (long) (BgL_cz00_999)))));
											{	/* Unsafe/sha2.scm 389 */

												BgL_t2z00_1010 =
													(unsigned long) (
													((long) (
															(unsigned long) (
																((long) (
																		(unsigned long) (
																			(((long) 65535) &
																				((long) (
																						(BgL_n1z00_3584 >>
																							(int) (((long) 16)))) +
																					(long) (
																						(BgL_n2z00_3585 >>
																							(int) (((long) 16)))))))) <<
																	(int) (((long) 16))))) +
														(long) (
															(unsigned long) (
																((long) (
																		(unsigned long) (
																			((long) (BgL_n1z00_3584) & ((long)
																					65535)))) +
																	(long) ((unsigned
																			long) (((long) (BgL_n2z00_3585) & ((long)
																					65535)))))))));
										}}
										{	/* Unsafe/sha2.scm 389 */

											{	/* Unsafe/sha2.scm 390 */
												unsigned long BgL_arg1445z00_1011;
												unsigned long BgL_arg1446z00_1012;
												obj_t BgL_arg1447z00_1013;

												{	/* Unsafe/sha2.scm 390 */

													BgL_arg1445z00_1011 =
														(unsigned long) (
														((long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				(((long) 65535) &
																					((long) (
																							(BgL_t1z00_1009 >>
																								(int) (((long) 16)))) +
																						(long) (
																							(BgL_t2z00_1010 >>
																								(int) (((long) 16)))))))) <<
																		(int) (((long) 16))))) +
															(long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				((long) (BgL_t1z00_1009) & ((long)
																						65535)))) +
																		(long) ((unsigned
																				long) (((long) (BgL_t2z00_1010) &
																					((long) 65535)))))))));
												}
												{	/* Unsafe/sha2.scm 390 */

													BgL_arg1446z00_1012 =
														(unsigned long) (
														((long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				(((long) 65535) &
																					((long) (
																							(BgL_dz00_1000 >>
																								(int) (((long) 16)))) +
																						(long) (
																							(BgL_t1z00_1009 >>
																								(int) (((long) 16)))))))) <<
																		(int) (((long) 16))))) +
															(long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				((long) (BgL_dz00_1000) & ((long)
																						65535)))) +
																		(long) ((unsigned
																				long) (((long) (BgL_t1z00_1009) &
																					((long) 65535)))))))));
												}
												BgL_arg1447z00_1013 =
													BGL_SAFE_PLUS_FX(BgL_jz00_1005, ((long) 1));
												{
													long BgL_jz00_4394;
													unsigned long BgL_hz00_4393;
													unsigned long BgL_gz00_4392;
													unsigned long BgL_fz00_4391;
													unsigned long BgL_ez00_4390;
													unsigned long BgL_dz00_4389;
													unsigned long BgL_cz00_4388;
													unsigned long BgL_bz00_4387;
													unsigned long BgL_az00_4386;

													BgL_az00_4386 = BgL_arg1445z00_1011;
													BgL_bz00_4387 = BgL_az00_997;
													BgL_cz00_4388 = BgL_bz00_998;
													BgL_dz00_4389 = BgL_cz00_999;
													BgL_ez00_4390 = BgL_arg1446z00_1012;
													BgL_fz00_4391 = BgL_ez00_1001;
													BgL_gz00_4392 = BgL_fz00_1002;
													BgL_hz00_4393 = BgL_gz00_1003;
													BgL_jz00_4394 = (long) CINT(BgL_arg1447z00_1013);
													BgL_jz00_1005 = BgL_jz00_4394;
													BgL_hz00_1004 = BgL_hz00_4393;
													BgL_gz00_1003 = BgL_gz00_4392;
													BgL_fz00_1002 = BgL_fz00_4391;
													BgL_ez00_1001 = BgL_ez00_4390;
													BgL_dz00_1000 = BgL_dz00_4389;
													BgL_cz00_999 = BgL_cz00_4388;
													BgL_bz00_998 = BgL_bz00_4387;
													BgL_az00_997 = BgL_az00_4386;
													goto BgL_zc3anonymousza31438ze3z83_1006;
												}
											}
										}
									}
								}
							}
						else
							{	/* Unsafe/sha2.scm 386 */
								if ((BgL_jz00_1005 < ((long) 64)))
									{	/* Unsafe/sha2.scm 392 */
										unsigned long BgL_s0z00_1018;

										{	/* Unsafe/sha2.scm 392 */
											unsigned long BgL_arg1469z00_1038;

											{	/* Unsafe/sha2.scm 392 */
												obj_t BgL_arg1470z00_1039;

												BgL_arg1470z00_1039 =
													BGL_SAFE_PLUS_FX(BgL_jz00_1005, ((long) 1));
												{	/* Unsafe/sha2.scm 392 */
													long BgL_nz00_2758;

													BgL_nz00_2758 = (long) CINT(BgL_arg1470z00_1039);
													{	/* Unsafe/sha2.scm 392 */
														long BgL_auxz00_4400;

														BgL_auxz00_4400 = (BgL_nz00_2758 & ((long) 15));
														BgL_arg1469z00_1038 =
															BGL_U32VREF(BgL_bufferz00_30, BgL_auxz00_4400);
											}}}
											BgL_s0z00_1018 =
												(unsigned long) (
												((long) (BGl_rotr32z00zz__sha2z00(BgL_arg1469z00_1038,
															(int) (((long) 7)))) ^
													((long) (BGl_rotr32z00zz__sha2z00(BgL_arg1469z00_1038,
																(int) (((long) 18)))) ^
														(long) (
															(BgL_arg1469z00_1038 >> (int) (((long) 3)))))));
										}
										{	/* Unsafe/sha2.scm 392 */
											unsigned long BgL_s1z00_1019;

											{	/* Unsafe/sha2.scm 393 */
												unsigned long BgL_arg1466z00_1035;

												{	/* Unsafe/sha2.scm 393 */
													obj_t BgL_arg1467z00_1036;

													BgL_arg1467z00_1036 =
														BGL_SAFE_PLUS_FX(BgL_jz00_1005, ((long) 14));
													{	/* Unsafe/sha2.scm 393 */
														long BgL_nz00_2781;

														BgL_nz00_2781 = (long) CINT(BgL_arg1467z00_1036);
														{	/* Unsafe/sha2.scm 393 */
															long BgL_auxz00_4417;

															BgL_auxz00_4417 = (BgL_nz00_2781 & ((long) 15));
															BgL_arg1466z00_1035 =
																BGL_U32VREF(BgL_bufferz00_30, BgL_auxz00_4417);
												}}}
												BgL_s1z00_1019 =
													(unsigned long) (
													((long) (BGl_rotr32z00zz__sha2z00(BgL_arg1466z00_1035,
																(int) (((long) 17)))) ^
														((long) (BGl_rotr32z00zz__sha2z00
																(BgL_arg1466z00_1035,
																	(int) (((long) 19)))) ^
															(long) ((BgL_arg1466z00_1035 >> (int) (((long)
																			10)))))));
											}
											{	/* Unsafe/sha2.scm 393 */
												long BgL_ndxz00_1020;

												BgL_ndxz00_1020 =
													(BgL_jz00_1005 &
													LLONG_TO_LONG(((BGL_LONGLONG_T) 15)));
												{	/* Unsafe/sha2.scm 394 */
													unsigned long BgL_wz00_1021;

													{	/* Unsafe/sha2.scm 395 */
														unsigned long BgL_arg1459z00_1030;
														unsigned long BgL_arg1460z00_1031;

														{	/* Unsafe/sha2.scm 395 */
															long BgL_auxz00_4434;

															BgL_auxz00_4434 = (BgL_jz00_1005 & ((long) 15));
															BgL_arg1459z00_1030 =
																BGL_U32VREF(BgL_bufferz00_30, BgL_auxz00_4434);
														}
														{	/* Unsafe/sha2.scm 395 */
															unsigned long BgL_arg1461z00_1032;

															{	/* Unsafe/sha2.scm 395 */
																unsigned long BgL_arg1464z00_1033;

																{	/* Unsafe/sha2.scm 395 */
																	long BgL_arg1465z00_1034;

																	BgL_arg1465z00_1034 =
																		(BgL_jz00_1005 + ((long) 9));
																	{	/* Unsafe/sha2.scm 395 */
																		long BgL_auxz00_4438;

																		BgL_auxz00_4438 =
																			(BgL_arg1465z00_1034 & ((long) 15));
																		BgL_arg1464z00_1033 =
																			BGL_U32VREF(BgL_bufferz00_30,
																			BgL_auxz00_4438);
																}}
																{	/* Unsafe/sha2.scm 395 */

																	BgL_arg1461z00_1032 =
																		(unsigned long) (
																		((long) (
																				(unsigned long) (
																					((long) (
																							(unsigned long) (
																								(((long) 65535) &
																									((long) (
																											(BgL_arg1464z00_1033 >>
																												(int) (((long) 16)))) +
																										(long) (
																											(BgL_s0z00_1018 >>
																												(int) (((long)
																														16)))))))) <<
																						(int) (((long) 16))))) +
																			(long) ((unsigned
																					long) (((long) ((unsigned
																								long) (((long)
																									(BgL_arg1464z00_1033) &
																									((long) 65535)))) +
																						(long) ((unsigned
																								long) (((long) (BgL_s0z00_1018)
																									& ((long) 65535)))))))));
															}}
															{	/* Unsafe/sha2.scm 395 */

																BgL_arg1460z00_1031 =
																	(unsigned long) (
																	((long) (
																			(unsigned long) (
																				((long) (
																						(unsigned long) (
																							(((long) 65535) &
																								((long) (
																										(BgL_s1z00_1019 >>
																											(int) (((long) 16)))) +
																									(long) (
																										(BgL_arg1461z00_1032 >>
																											(int) (((long) 16))))))))
																					<< (int) (((long) 16))))) +
																		(long) ((unsigned long) (((long) ((unsigned
																							long) (((long) (BgL_s1z00_1019) &
																								((long) 65535)))) +
																					(long) ((unsigned
																							long) (((long)
																								(BgL_arg1461z00_1032) & ((long)
																									65535)))))))));
														}}
														{	/* Unsafe/sha2.scm 395 */

															BgL_wz00_1021 =
																(unsigned long) (
																((long) (
																		(unsigned long) (
																			((long) (
																					(unsigned long) (
																						(((long) 65535) &
																							((long) (
																									(BgL_arg1459z00_1030 >>
																										(int) (((long) 16)))) +
																								(long) (
																									(BgL_arg1460z00_1031 >>
																										(int) (((long) 16)))))))) <<
																				(int) (((long) 16))))) +
																	(long) (
																		(unsigned long) (
																			((long) (
																					(unsigned long) (
																						((long) (BgL_arg1459z00_1030) &
																							((long) 65535)))) +
																				(long) ((unsigned
																						long) (((long) (BgL_arg1460z00_1031)
																							& ((long) 65535)))))))));
													}}
													{	/* Unsafe/sha2.scm 395 */
														unsigned long BgL_t1z00_1022;

														{	/* Unsafe/sha2.scm 396 */
															unsigned long BgL_arg1474z00_2825;

															{	/* Unsafe/sha2.scm 396 */
																unsigned long BgL_arg1475z00_2826;
																unsigned long BgL_arg1477z00_2827;

																BgL_arg1475z00_2826 =
																	BGl_Sigma1zd2256zd2zz__sha2z00(BgL_ez00_1001);
																{	/* Unsafe/sha2.scm 396 */
																	unsigned long BgL_arg1478z00_2828;
																	unsigned long BgL_arg1480z00_2829;

																	BgL_arg1478z00_2828 =
																		(unsigned long) (
																		(((long) (BgL_ez00_1001) &
																				(long) (BgL_fz00_1002)) ^
																			(~((long) (BgL_ez00_1001)) &
																				(long) (BgL_gz00_1003))));
																	{	/* Unsafe/sha2.scm 396 */
																		unsigned long BgL_arg1481z00_2830;

																		BgL_arg1481z00_2830 =
																			BGL_U32VREF(BGl_K256z00zz__sha2z00,
																			BgL_jz00_1005);
																		{	/* Unsafe/sha2.scm 396 */

																			BgL_arg1480z00_2829 =
																				(unsigned long) (
																				((long) (
																						(unsigned long) (
																							((long) (
																									(unsigned long) (
																										(((long) 65535) &
																											((long) (
																													(BgL_arg1481z00_2830
																														>> (int) (((long)
																																16)))) +
																												(long) ((BgL_wz00_1021
																														>> (int) (((long)
																																16)))))))) <<
																								(int) (((long) 16))))) +
																					(long) ((unsigned
																							long) (((long) ((unsigned
																										long) (((long)
																											(BgL_arg1481z00_2830) &
																											((long) 65535)))) +
																								(long) ((unsigned
																										long) (((long)
																											(BgL_wz00_1021) & ((long)
																												65535)))))))));
																	}}
																	{	/* Unsafe/sha2.scm 396 */

																		BgL_arg1477z00_2827 =
																			(unsigned long) (
																			((long) (
																					(unsigned long) (
																						((long) (
																								(unsigned long) (
																									(((long) 65535) &
																										((long) (
																												(BgL_arg1478z00_2828 >>
																													(int) (((long) 16))))
																											+
																											(long) (
																												(BgL_arg1480z00_2829 >>
																													(int) (((long)
																															16)))))))) <<
																							(int) (((long) 16))))) +
																				(long) ((unsigned
																						long) (((long) ((unsigned
																									long) (((long)
																										(BgL_arg1478z00_2828) &
																										((long) 65535)))) +
																							(long) ((unsigned
																									long) (((long)
																										(BgL_arg1480z00_2829) &
																										((long) 65535)))))))));
																}}
																{	/* Unsafe/sha2.scm 396 */

																	BgL_arg1474z00_2825 =
																		(unsigned long) (
																		((long) (
																				(unsigned long) (
																					((long) (
																							(unsigned long) (
																								(((long) 65535) &
																									((long) (
																											(BgL_arg1475z00_2826 >>
																												(int) (((long) 16)))) +
																										(long) (
																											(BgL_arg1477z00_2827 >>
																												(int) (((long)
																														16)))))))) <<
																						(int) (((long) 16))))) +
																			(long) ((unsigned
																					long) (((long) ((unsigned
																								long) (((long)
																									(BgL_arg1475z00_2826) &
																									((long) 65535)))) +
																						(long) ((unsigned
																								long) (((long)
																									(BgL_arg1477z00_2827) &
																									((long) 65535)))))))));
															}}
															{	/* Unsafe/sha2.scm 396 */

																BgL_t1z00_1022 =
																	(unsigned long) (
																	((long) (
																			(unsigned long) (
																				((long) (
																						(unsigned long) (
																							(((long) 65535) &
																								((long) (
																										(BgL_hz00_1004 >>
																											(int) (((long) 16)))) +
																									(long) (
																										(BgL_arg1474z00_2825 >>
																											(int) (((long) 16))))))))
																					<< (int) (((long) 16))))) +
																		(long) ((unsigned long) (((long) ((unsigned
																							long) (((long) (BgL_hz00_1004) &
																								((long) 65535)))) +
																					(long) ((unsigned
																							long) (((long)
																								(BgL_arg1474z00_2825) & ((long)
																									65535)))))))));
														}}
														{	/* Unsafe/sha2.scm 396 */
															unsigned long BgL_t2z00_1023;

															{	/* Unsafe/sha2.scm 397 */
																unsigned long BgL_n1z00_3604;
																unsigned long BgL_n2z00_3605;

																BgL_n1z00_3604 =
																	(unsigned long) (
																	((long) (BGl_rotr32z00zz__sha2z00
																			(BgL_az00_997,
																				(int) (((long) 2)))) ^
																		((long) (BGl_rotr32z00zz__sha2z00
																				(BgL_az00_997,
																					(int) (((long) 13)))) ^
																			(long) (BGl_rotr32z00zz__sha2z00
																				(BgL_az00_997, (int) (((long) 22)))))));
																BgL_n2z00_3605 =
																	(unsigned long) ((((long) (BgL_az00_997) &
																			(long) (BgL_bz00_998)) ^
																		(((long) (BgL_az00_997) &
																				(long) (BgL_cz00_999)) ^
																			((long) (BgL_bz00_998) &
																				(long) (BgL_cz00_999)))));
																{	/* Unsafe/sha2.scm 397 */

																	BgL_t2z00_1023 =
																		(unsigned long) (
																		((long) (
																				(unsigned long) (
																					((long) (
																							(unsigned long) (
																								(((long) 65535) &
																									((long) (
																											(BgL_n1z00_3604 >>
																												(int) (((long) 16)))) +
																										(long) (
																											(BgL_n2z00_3605 >>
																												(int) (((long)
																														16)))))))) <<
																						(int) (((long) 16))))) +
																			(long) ((unsigned
																					long) (((long) ((unsigned
																								long) (((long) (BgL_n1z00_3604)
																									& ((long) 65535)))) +
																						(long) ((unsigned
																								long) (((long) (BgL_n2z00_3605)
																									& ((long) 65535)))))))));
															}}
															{	/* Unsafe/sha2.scm 397 */

																BGL_U32VSET(BgL_bufferz00_30, BgL_ndxz00_1020,
																	BgL_wz00_1021);
																BUNSPEC;
																{	/* Unsafe/sha2.scm 399 */
																	unsigned long BgL_arg1452z00_1024;
																	unsigned long BgL_arg1453z00_1025;
																	obj_t BgL_arg1454z00_1026;

																	{	/* Unsafe/sha2.scm 399 */

																		BgL_arg1452z00_1024 =
																			(unsigned long) (
																			((long) (
																					(unsigned long) (
																						((long) (
																								(unsigned long) (
																									(((long) 65535) &
																										((long) (
																												(BgL_t1z00_1022 >>
																													(int) (((long) 16))))
																											+
																											(long) ((BgL_t2z00_1023 >>
																													(int) (((long)
																															16)))))))) <<
																							(int) (((long) 16))))) +
																				(long) ((unsigned
																						long) (((long) ((unsigned
																									long) (((long)
																										(BgL_t1z00_1022) & ((long)
																											65535)))) +
																							(long) ((unsigned
																									long) (((long)
																										(BgL_t2z00_1023) & ((long)
																											65535)))))))));
																	}
																	{	/* Unsafe/sha2.scm 399 */

																		BgL_arg1453z00_1025 =
																			(unsigned long) (
																			((long) (
																					(unsigned long) (
																						((long) (
																								(unsigned long) (
																									(((long) 65535) &
																										((long) (
																												(BgL_dz00_1000 >>
																													(int) (((long) 16))))
																											+
																											(long) ((BgL_t1z00_1022 >>
																													(int) (((long)
																															16)))))))) <<
																							(int) (((long) 16))))) +
																				(long) ((unsigned
																						long) (((long) ((unsigned
																									long) (((long) (BgL_dz00_1000)
																										& ((long) 65535)))) +
																							(long) ((unsigned
																									long) (((long)
																										(BgL_t1z00_1022) & ((long)
																											65535)))))))));
																	}
																	BgL_arg1454z00_1026 =
																		BGL_SAFE_PLUS_FX(BgL_jz00_1005, ((long) 1));
																	{
																		long BgL_jz00_4756;
																		unsigned long BgL_hz00_4755;
																		unsigned long BgL_gz00_4754;
																		unsigned long BgL_fz00_4753;
																		unsigned long BgL_ez00_4752;
																		unsigned long BgL_dz00_4751;
																		unsigned long BgL_cz00_4750;
																		unsigned long BgL_bz00_4749;
																		unsigned long BgL_az00_4748;

																		BgL_az00_4748 = BgL_arg1452z00_1024;
																		BgL_bz00_4749 = BgL_az00_997;
																		BgL_cz00_4750 = BgL_bz00_998;
																		BgL_dz00_4751 = BgL_cz00_999;
																		BgL_ez00_4752 = BgL_arg1453z00_1025;
																		BgL_fz00_4753 = BgL_ez00_1001;
																		BgL_gz00_4754 = BgL_fz00_1002;
																		BgL_hz00_4755 = BgL_gz00_1003;
																		BgL_jz00_4756 =
																			(long) CINT(BgL_arg1454z00_1026);
																		BgL_jz00_1005 = BgL_jz00_4756;
																		BgL_hz00_1004 = BgL_hz00_4755;
																		BgL_gz00_1003 = BgL_gz00_4754;
																		BgL_fz00_1002 = BgL_fz00_4753;
																		BgL_ez00_1001 = BgL_ez00_4752;
																		BgL_dz00_1000 = BgL_dz00_4751;
																		BgL_cz00_999 = BgL_cz00_4750;
																		BgL_bz00_998 = BgL_bz00_4749;
																		BgL_az00_997 = BgL_az00_4748;
																		goto BgL_zc3anonymousza31438ze3z83_1006;
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								else
									{	/* Unsafe/sha2.scm 391 */
										BgL_statez00_1079 = BgL_statez00_29;
										BgL_az00_1080 = BgL_az00_997;
										BgL_bz00_1081 = BgL_bz00_998;
										BgL_cz00_1082 = BgL_cz00_999;
										BgL_dz00_1083 = BgL_dz00_1000;
										BgL_ez00_1084 = BgL_ez00_1001;
										BgL_fz00_1085 = BgL_fz00_1002;
										BgL_gz00_1086 = BgL_gz00_1003;
										BgL_hz00_1087 = BgL_hz00_1004;
										{	/* Unsafe/sha2.scm 358 */
											unsigned long BgL_oaz00_1089;
											unsigned long BgL_obz00_1090;
											unsigned long BgL_ocz00_1091;
											unsigned long BgL_odz00_1092;
											unsigned long BgL_oez00_1093;
											unsigned long BgL_ofz00_1094;
											unsigned long BgL_ogz00_1095;
											unsigned long BgL_ohz00_1096;

											{	/* Unsafe/sha2.scm 358 */
												unsigned long BgL_res2271z00_2651;

												BgL_res2271z00_2651 =
													BGL_U32VREF(BgL_statez00_1079, ((long) 0));
												BgL_oaz00_1089 = BgL_res2271z00_2651;
											}
											{	/* Unsafe/sha2.scm 359 */
												unsigned long BgL_res2272z00_2653;

												BgL_res2272z00_2653 =
													BGL_U32VREF(BgL_statez00_1079, ((long) 1));
												BgL_obz00_1090 = BgL_res2272z00_2653;
											}
											{	/* Unsafe/sha2.scm 360 */
												unsigned long BgL_res2273z00_2655;

												BgL_res2273z00_2655 =
													BGL_U32VREF(BgL_statez00_1079, ((long) 2));
												BgL_ocz00_1091 = BgL_res2273z00_2655;
											}
											{	/* Unsafe/sha2.scm 361 */
												unsigned long BgL_res2274z00_2657;

												BgL_res2274z00_2657 =
													BGL_U32VREF(BgL_statez00_1079, ((long) 3));
												BgL_odz00_1092 = BgL_res2274z00_2657;
											}
											{	/* Unsafe/sha2.scm 362 */
												unsigned long BgL_res2275z00_2659;

												BgL_res2275z00_2659 =
													BGL_U32VREF(BgL_statez00_1079, ((long) 4));
												BgL_oez00_1093 = BgL_res2275z00_2659;
											}
											{	/* Unsafe/sha2.scm 363 */
												unsigned long BgL_res2276z00_2661;

												BgL_res2276z00_2661 =
													BGL_U32VREF(BgL_statez00_1079, ((long) 5));
												BgL_ofz00_1094 = BgL_res2276z00_2661;
											}
											{	/* Unsafe/sha2.scm 364 */
												unsigned long BgL_res2277z00_2663;

												BgL_res2277z00_2663 =
													BGL_U32VREF(BgL_statez00_1079, ((long) 6));
												BgL_ogz00_1095 = BgL_res2277z00_2663;
											}
											{	/* Unsafe/sha2.scm 365 */
												unsigned long BgL_res2278z00_2665;

												BgL_res2278z00_2665 =
													BGL_U32VREF(BgL_statez00_1079, ((long) 7));
												BgL_ohz00_1096 = BgL_res2278z00_2665;
											}
											{	/* Unsafe/sha2.scm 367 */
												unsigned long BgL_arg1506z00_1098;

												{	/* Unsafe/sha2.scm 367 */

													BgL_arg1506z00_1098 =
														(unsigned long) (
														((long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				(((long) 65535) &
																					((long) (
																							(BgL_oaz00_1089 >>
																								(int) (((long) 16)))) +
																						(long) (
																							(BgL_az00_1080 >>
																								(int) (((long) 16)))))))) <<
																		(int) (((long) 16))))) +
															(long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				((long) (BgL_oaz00_1089) & ((long)
																						65535)))) +
																		(long) ((unsigned
																				long) (((long) (BgL_az00_1080) & ((long)
																						65535)))))))));
												}
												BGL_U32VSET(BgL_statez00_1079, ((long) 0),
													BgL_arg1506z00_1098);
												BUNSPEC;
											}
											{	/* Unsafe/sha2.scm 368 */
												unsigned long BgL_arg1507z00_1099;

												{	/* Unsafe/sha2.scm 368 */

													BgL_arg1507z00_1099 =
														(unsigned long) (
														((long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				(((long) 65535) &
																					((long) (
																							(BgL_obz00_1090 >>
																								(int) (((long) 16)))) +
																						(long) (
																							(BgL_bz00_1081 >>
																								(int) (((long) 16)))))))) <<
																		(int) (((long) 16))))) +
															(long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				((long) (BgL_obz00_1090) & ((long)
																						65535)))) +
																		(long) ((unsigned
																				long) (((long) (BgL_bz00_1081) & ((long)
																						65535)))))))));
												}
												BGL_U32VSET(BgL_statez00_1079, ((long) 1),
													BgL_arg1507z00_1099);
												BUNSPEC;
											}
											{	/* Unsafe/sha2.scm 369 */
												unsigned long BgL_arg1508z00_1100;

												{	/* Unsafe/sha2.scm 369 */

													BgL_arg1508z00_1100 =
														(unsigned long) (
														((long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				(((long) 65535) &
																					((long) (
																							(BgL_ocz00_1091 >>
																								(int) (((long) 16)))) +
																						(long) (
																							(BgL_cz00_1082 >>
																								(int) (((long) 16)))))))) <<
																		(int) (((long) 16))))) +
															(long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				((long) (BgL_ocz00_1091) & ((long)
																						65535)))) +
																		(long) ((unsigned
																				long) (((long) (BgL_cz00_1082) & ((long)
																						65535)))))))));
												}
												BGL_U32VSET(BgL_statez00_1079, ((long) 2),
													BgL_arg1508z00_1100);
												BUNSPEC;
											}
											{	/* Unsafe/sha2.scm 370 */
												unsigned long BgL_arg1509z00_1101;

												{	/* Unsafe/sha2.scm 370 */

													BgL_arg1509z00_1101 =
														(unsigned long) (
														((long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				(((long) 65535) &
																					((long) (
																							(BgL_odz00_1092 >>
																								(int) (((long) 16)))) +
																						(long) (
																							(BgL_dz00_1083 >>
																								(int) (((long) 16)))))))) <<
																		(int) (((long) 16))))) +
															(long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				((long) (BgL_odz00_1092) & ((long)
																						65535)))) +
																		(long) ((unsigned
																				long) (((long) (BgL_dz00_1083) & ((long)
																						65535)))))))));
												}
												BGL_U32VSET(BgL_statez00_1079, ((long) 3),
													BgL_arg1509z00_1101);
												BUNSPEC;
											}
											{	/* Unsafe/sha2.scm 371 */
												unsigned long BgL_arg1510z00_1102;

												{	/* Unsafe/sha2.scm 371 */

													BgL_arg1510z00_1102 =
														(unsigned long) (
														((long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				(((long) 65535) &
																					((long) (
																							(BgL_oez00_1093 >>
																								(int) (((long) 16)))) +
																						(long) (
																							(BgL_ez00_1084 >>
																								(int) (((long) 16)))))))) <<
																		(int) (((long) 16))))) +
															(long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				((long) (BgL_oez00_1093) & ((long)
																						65535)))) +
																		(long) ((unsigned
																				long) (((long) (BgL_ez00_1084) & ((long)
																						65535)))))))));
												}
												BGL_U32VSET(BgL_statez00_1079, ((long) 4),
													BgL_arg1510z00_1102);
												BUNSPEC;
											}
											{	/* Unsafe/sha2.scm 372 */
												unsigned long BgL_arg1511z00_1103;

												{	/* Unsafe/sha2.scm 372 */

													BgL_arg1511z00_1103 =
														(unsigned long) (
														((long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				(((long) 65535) &
																					((long) (
																							(BgL_ofz00_1094 >>
																								(int) (((long) 16)))) +
																						(long) (
																							(BgL_fz00_1085 >>
																								(int) (((long) 16)))))))) <<
																		(int) (((long) 16))))) +
															(long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				((long) (BgL_ofz00_1094) & ((long)
																						65535)))) +
																		(long) ((unsigned
																				long) (((long) (BgL_fz00_1085) & ((long)
																						65535)))))))));
												}
												BGL_U32VSET(BgL_statez00_1079, ((long) 5),
													BgL_arg1511z00_1103);
												BUNSPEC;
											}
											{	/* Unsafe/sha2.scm 373 */
												unsigned long BgL_arg1512z00_1104;

												{	/* Unsafe/sha2.scm 373 */

													BgL_arg1512z00_1104 =
														(unsigned long) (
														((long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				(((long) 65535) &
																					((long) (
																							(BgL_ogz00_1095 >>
																								(int) (((long) 16)))) +
																						(long) (
																							(BgL_gz00_1086 >>
																								(int) (((long) 16)))))))) <<
																		(int) (((long) 16))))) +
															(long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				((long) (BgL_ogz00_1095) & ((long)
																						65535)))) +
																		(long) ((unsigned
																				long) (((long) (BgL_gz00_1086) & ((long)
																						65535)))))))));
												}
												BGL_U32VSET(BgL_statez00_1079, ((long) 6),
													BgL_arg1512z00_1104);
												BUNSPEC;
											}
											{	/* Unsafe/sha2.scm 374 */
												unsigned long BgL_arg1513z00_1105;

												{	/* Unsafe/sha2.scm 374 */

													BgL_arg1513z00_1105 =
														(unsigned long) (
														((long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				(((long) 65535) &
																					((long) (
																							(BgL_ohz00_1096 >>
																								(int) (((long) 16)))) +
																						(long) (
																							(BgL_hz00_1087 >>
																								(int) (((long) 16)))))))) <<
																		(int) (((long) 16))))) +
															(long) (
																(unsigned long) (
																	((long) (
																			(unsigned long) (
																				((long) (BgL_ohz00_1096) & ((long)
																						65535)))) +
																		(long) ((unsigned
																				long) (((long) (BgL_hz00_1087) & ((long)
																						65535)))))))));
												}
												BGL_U32VSET(BgL_statez00_1079, ((long) 7),
													BgL_arg1513z00_1105);
												BUNSPEC;
										}}
										return BgL_statez00_29;
									}
							}
					}
				}
			}
		}
	}



/* sha256-update */
	obj_t BGl_sha256zd2updatezd2zz__sha2z00(obj_t BgL_statez00_36,
		obj_t BgL_bufferz00_37, obj_t BgL_oz00_38, obj_t BgL_fillzd2wordz12zc0_39)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 437 */
			{
				obj_t BgL_bufferz00_1161;
				long BgL_iz00_1162;

				{
					long BgL_iz00_1146;
					long BgL_lz00_1147;

					BgL_iz00_1146 = ((long) 0);
					BgL_lz00_1147 = ((long) 0);
				BgL_zc3anonymousza31533ze3z83_1148:
					{	/* Unsafe/sha2.scm 451 */
						long BgL_bytesz00_1149;

						BgL_bufferz00_1161 = BgL_bufferz00_37;
						BgL_iz00_1162 = BgL_iz00_1146;
						{
							long BgL_jz00_2918;
							long BgL_iz00_2919;
							long BgL_nz00_2920;

							BgL_jz00_2918 = ((long) 0);
							BgL_iz00_2919 = BgL_iz00_1162;
							BgL_nz00_2920 = ((long) 0);
						BgL_loopz00_2917:
							if ((BgL_jz00_2918 < ((long) 16)))
								{	/* Unsafe/sha2.scm 442 */
									long BgL_arg1552z00_2927;
									long BgL_arg1553z00_2928;
									long BgL_arg1554z00_2929;

									BgL_arg1552z00_2927 = (BgL_jz00_2918 + ((long) 1));
									BgL_arg1553z00_2928 = (BgL_iz00_2919 + ((long) 4));
									{	/* Unsafe/sha2.scm 442 */
										long BgL_arg1555z00_2930;

										BgL_arg1555z00_2930 =
											((long (*)())
											PROCEDURE_L_ENTRY(BgL_fillzd2wordz12zc0_39))
											(BgL_fillzd2wordz12zc0_39, BgL_bufferz00_1161,
											BINT(BgL_jz00_2918), BgL_oz00_38, BINT(BgL_iz00_2919));
										BgL_arg1554z00_2929 =
											(long)
											CINT(BGl_2zb2zb2zz__r4_numbers_6_5z00(BINT(BgL_nz00_2920),
												BINT(BgL_arg1555z00_2930)));
									}
									{
										long BgL_nz00_5009;
										long BgL_iz00_5008;
										long BgL_jz00_5007;

										BgL_jz00_5007 = BgL_arg1552z00_2927;
										BgL_iz00_5008 = BgL_arg1553z00_2928;
										BgL_nz00_5009 = BgL_arg1554z00_2929;
										BgL_nz00_2920 = BgL_nz00_5009;
										BgL_iz00_2919 = BgL_iz00_5008;
										BgL_jz00_2918 = BgL_jz00_5007;
										goto BgL_loopz00_2917;
									}
								}
							else
								{	/* Unsafe/sha2.scm 442 */
									BgL_bytesz00_1149 = BgL_nz00_2920;
								}
						}
						if ((BgL_bytesz00_1149 == ((long) 64)))
							{	/* Unsafe/sha2.scm 453 */
								BGl_sha256zd2internalzd2transformz00zz__sha2z00(BgL_statez00_36,
									BgL_bufferz00_37);
								{
									long BgL_lz00_5015;
									long BgL_iz00_5013;

									BgL_iz00_5013 = (BgL_iz00_1146 + ((long) 64));
									BgL_lz00_5015 = (BgL_lz00_1147 + ((long) 64));
									BgL_lz00_1147 = BgL_lz00_5015;
									BgL_iz00_1146 = BgL_iz00_5013;
									goto BgL_zc3anonymousza31533ze3z83_1148;
								}
							}
						else
							{	/* Unsafe/sha2.scm 453 */
								if (((((long) 64) - BgL_bytesz00_1149) >= ((long) 8)))
									{	/* Unsafe/sha2.scm 457 */
										{	/* Unsafe/sha2.scm 460 */
											unsigned long BgL_ulenz00_1154;

											BgL_ulenz00_1154 =
												(unsigned long) (
												(((long) 8) *
													((BgL_lz00_1147 - ((long) 1)) + BgL_bytesz00_1149)));
											BGL_U32VSET(BgL_bufferz00_37, ((long) 15),
												BgL_ulenz00_1154);
											BUNSPEC;
										}
										return
											BGl_sha256zd2internalzd2transformz00zz__sha2z00
											(BgL_statez00_36, BgL_bufferz00_37);
									}
								else
									{	/* Unsafe/sha2.scm 457 */
										BGl_sha256zd2internalzd2transformz00zz__sha2z00
											(BgL_statez00_36, BgL_bufferz00_37);
										{
											long BgL_lz00_5029;
											long BgL_iz00_5027;

											BgL_iz00_5027 = (((long) 64) + BgL_bytesz00_1149);
											BgL_lz00_5029 = (BgL_lz00_1147 + BgL_bytesz00_1149);
											BgL_lz00_1147 = BgL_lz00_5029;
											BgL_iz00_1146 = BgL_iz00_5027;
											goto BgL_zc3anonymousza31533ze3z83_1148;
										}
									}
							}
					}
				}
			}
		}
	}



/* sha256sum-mmap */
	BGL_EXPORTED_DEF obj_t BGl_sha256sumzd2mmapzd2zz__sha2z00(obj_t BgL_mmz00_40)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 471 */
			{	/* Unsafe/sha2.scm 508 */
				obj_t BgL_statez00_1178;
				obj_t BgL_bufferz00_1179;

				BgL_statez00_1178 = BGl_sha256zd2initialzd2hashzd2valuezd2zz__sha2z00();
				{	/* Llib/srfi4.scm 236 */

					BgL_bufferz00_1179 =
						BGl_makezd2u32vectorzd2zz__srfi4z00(((long) 16), BINT(((long) 0)));
				}
				BGl_sha256zd2updatezd2zz__sha2z00(BgL_statez00_1178, BgL_bufferz00_1179,
					BgL_mmz00_40, BGl_proc2502z00zz__sha2z00);
				return BGl_statezd2ze3stringz31zz__sha2z00(BgL_statez00_1178);
			}
		}
	}



/* &sha256sum-mmap */
	obj_t BGl_z62sha256sumzd2mmapzb0zz__sha2z00(obj_t BgL_envz00_3511,
		obj_t BgL_mmz00_3512)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 471 */
			{	/* Unsafe/sha2.scm 474 */
				obj_t BgL_auxz00_5036;

				if (BGL_MMAPP(BgL_mmz00_3512))
					{	/* Unsafe/sha2.scm 474 */
						BgL_auxz00_5036 = BgL_mmz00_3512;
					}
				else
					{
						obj_t BgL_auxz00_5039;

						BgL_auxz00_5039 =
							BGl_typezd2errorzd2zz__errorz00(BGl_string2503z00zz__sha2z00,
							BINT(((long) 19810)), BGl_string2504z00zz__sha2z00,
							BGl_string2505z00zz__sha2z00, BgL_mmz00_3512);
						FAILURE(BgL_auxz00_5039, BFALSE, BFALSE);
					}
				return BGl_sha256sumzd2mmapzd2zz__sha2z00(BgL_auxz00_5036);
			}
		}
	}



/* &fill-word32-mmap! */
	long BGl_z62fillzd2word32zd2mmapz12z70zz__sha2z00(obj_t BgL_envz00_3513,
		obj_t BgL_v32z00_3514, obj_t BgL_iz00_3515, obj_t BgL_mmz00_3516,
		obj_t BgL_nz00_3517)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 506 */
			{
				obj_t BgL_v32z00_1186;
				long BgL_iz00_1187;
				obj_t BgL_mmz00_1188;
				long BgL_nz00_1189;

				BgL_v32z00_1186 = BgL_v32z00_3514;
				BgL_iz00_1187 = (long) CINT(BgL_iz00_3515);
				BgL_mmz00_1188 = BgL_mmz00_3516;
				BgL_nz00_1189 = (long) CINT(BgL_nz00_3517);
				{	/* Unsafe/sha2.scm 477 */
					long BgL_lz00_1191;

					{	/* Unsafe/sha2.scm 477 */
						long BgL_res2355z00_2974;

						BgL_res2355z00_2974 = BGL_MMAP_LENGTH(BgL_mmz00_1188);
						BgL_lz00_1191 = BgL_res2355z00_2974;
					}
					{	/* Unsafe/sha2.scm 479 */
						bool_t BgL_testz00_5045;

						{	/* Unsafe/sha2.scm 479 */
							long BgL_n2z00_2979;

							BgL_n2z00_2979 = ELONG_TO_LONG(BgL_lz00_1191);
							BgL_testz00_5045 =
								((BgL_nz00_1189 + ((long) 4)) <= BgL_n2z00_2979);
						}
						if (BgL_testz00_5045)
							{	/* Unsafe/sha2.scm 480 */
								unsigned long BgL_v0z00_1193;

								{	/* Unsafe/sha2.scm 480 */
									unsigned char BgL_arg1557z00_2983;

									{	/* Unsafe/sha2.scm 480 */
										long BgL_auxz00_5049;

										BgL_auxz00_5049 = LONG_TO_ELONG(BgL_nz00_1189);
										BgL_arg1557z00_2983 =
											BGL_MMAP_REF(BgL_mmz00_1188, BgL_auxz00_5049);
									}
									BgL_v0z00_1193 = (unsigned long) ((BgL_arg1557z00_2983));
								}
								{	/* Unsafe/sha2.scm 480 */
									unsigned long BgL_v1z00_1194;

									{	/* Unsafe/sha2.scm 481 */
										long BgL_arg1570z00_1205;

										BgL_arg1570z00_1205 = (BgL_nz00_1189 + ((long) 1));
										{	/* Unsafe/sha2.scm 481 */
											unsigned char BgL_arg1557z00_2991;

											{	/* Unsafe/sha2.scm 481 */
												long BgL_auxz00_5055;

												BgL_auxz00_5055 = LONG_TO_ELONG(BgL_arg1570z00_1205);
												BgL_arg1557z00_2991 =
													BGL_MMAP_REF(BgL_mmz00_1188, BgL_auxz00_5055);
											}
											BgL_v1z00_1194 = (unsigned long) ((BgL_arg1557z00_2991));
									}}
									{	/* Unsafe/sha2.scm 481 */
										unsigned long BgL_v2z00_1195;

										{	/* Unsafe/sha2.scm 482 */
											long BgL_arg1567z00_1204;

											BgL_arg1567z00_1204 = (BgL_nz00_1189 + ((long) 2));
											{	/* Unsafe/sha2.scm 482 */
												unsigned char BgL_arg1557z00_2999;

												{	/* Unsafe/sha2.scm 482 */
													long BgL_auxz00_5061;

													BgL_auxz00_5061 = LONG_TO_ELONG(BgL_arg1567z00_1204);
													BgL_arg1557z00_2999 =
														BGL_MMAP_REF(BgL_mmz00_1188, BgL_auxz00_5061);
												}
												BgL_v2z00_1195 =
													(unsigned long) ((BgL_arg1557z00_2999));
										}}
										{	/* Unsafe/sha2.scm 482 */
											unsigned long BgL_v3z00_1196;

											{	/* Unsafe/sha2.scm 483 */
												long BgL_arg1566z00_1203;

												BgL_arg1566z00_1203 = (BgL_nz00_1189 + ((long) 3));
												{	/* Unsafe/sha2.scm 483 */
													unsigned char BgL_arg1557z00_3007;

													{	/* Unsafe/sha2.scm 483 */
														long BgL_auxz00_5067;

														BgL_auxz00_5067 =
															LONG_TO_ELONG(BgL_arg1566z00_1203);
														BgL_arg1557z00_3007 =
															BGL_MMAP_REF(BgL_mmz00_1188, BgL_auxz00_5067);
													}
													BgL_v3z00_1196 =
														(unsigned long) ((BgL_arg1557z00_3007));
											}}
											{	/* Unsafe/sha2.scm 483 */
												unsigned long BgL_vz00_1197;

												BgL_vz00_1197 =
													(unsigned long) (
													(((((long) (BgL_v0z00_1193) <<
																	(int) (((long) 8))) |
																(long) (BgL_v1z00_1194)) <<
															(int) (((long) 16))) |
														(((long) (BgL_v2z00_1195) <<
																(int) (((long) 8))) |
															(long) (BgL_v3z00_1196))));
												{	/* Unsafe/sha2.scm 484 */

													BGL_U32VSET(BgL_v32z00_1186, BgL_iz00_1187,
														BgL_vz00_1197);
													BUNSPEC;
													return ((long) 4);
							}}}}}}
						else
							{	/* Unsafe/sha2.scm 487 */
								bool_t BgL_testz00_5087;

								{	/* Unsafe/sha2.scm 487 */
									long BgL_auxz00_5088;

									{	/* Unsafe/sha2.scm 487 */
										long BgL_za72za7_3029;

										BgL_za72za7_3029 = ELONG_TO_LONG(BgL_lz00_1191);
										BgL_auxz00_5088 = (((long) 1) + BgL_za72za7_3029);
									}
									BgL_testz00_5087 = (BgL_nz00_1189 >= BgL_auxz00_5088);
								}
								if (BgL_testz00_5087)
									{	/* Unsafe/sha2.scm 487 */
										{	/* Unsafe/sha2.scm 488 */
											unsigned long BgL_auxz00_5092;

											BgL_auxz00_5092 = (unsigned long) (((long) 0));
											BGL_U32VSET(BgL_v32z00_1186, BgL_iz00_1187,
												BgL_auxz00_5092);
										} BUNSPEC;
										return ((long) 0);
									}
								else
									{	/* Unsafe/sha2.scm 491 */
										obj_t BgL_vz00_1207;
										long BgL_kz00_1208;

										BgL_vz00_1207 =
											BGl_makezd2u32vectorzd2zz__srfi4z00(((long) 4),
											BINT(((long) 0)));
										{	/* Unsafe/sha2.scm 492 */
											long BgL_auxz00_5097;

											{	/* Unsafe/sha2.scm 492 */
												long BgL_za72za7_3038;

												BgL_za72za7_3038 = ELONG_TO_LONG(BgL_lz00_1191);
												BgL_auxz00_5097 =
													((BgL_nz00_1189 + ((long) 4)) - BgL_za72za7_3038);
											}
											BgL_kz00_1208 = (((long) 4) - BgL_auxz00_5097);
										}
										{
											long BgL_jz00_1210;

											BgL_jz00_1210 = ((long) 0);
										BgL_zc3anonymousza31572ze3z83_1211:
											if ((BgL_jz00_1210 == BgL_kz00_1208))
												{	/* Unsafe/sha2.scm 494 */
													{	/* Unsafe/sha2.scm 496 */
														unsigned long BgL_auxz00_5104;

														BgL_auxz00_5104 = (unsigned long) (((long) 128));
														BGL_U32VSET(BgL_vz00_1207, BgL_jz00_1210,
															BgL_auxz00_5104);
													} BUNSPEC;
													{	/* Unsafe/sha2.scm 497 */
														unsigned long BgL_v0z00_1213;

														BgL_v0z00_1213 =
															BGL_U32VREF(BgL_vz00_1207, ((long) 0));
														{	/* Unsafe/sha2.scm 497 */
															unsigned long BgL_v1z00_1214;

															BgL_v1z00_1214 =
																BGL_U32VREF(BgL_vz00_1207, ((long) 1));
															{	/* Unsafe/sha2.scm 498 */
																unsigned long BgL_v2z00_1215;

																BgL_v2z00_1215 =
																	BGL_U32VREF(BgL_vz00_1207, ((long) 2));
																{	/* Unsafe/sha2.scm 499 */
																	unsigned long BgL_v3z00_1216;

																	BgL_v3z00_1216 =
																		BGL_U32VREF(BgL_vz00_1207, ((long) 3));
																	{	/* Unsafe/sha2.scm 500 */
																		unsigned long BgL_vz00_1217;

																		BgL_vz00_1217 =
																			(unsigned long) (
																			(((((long) (BgL_v0z00_1213) <<
																							(int) (((long) 8))) |
																						(long) (BgL_v1z00_1214)) <<
																					(int) (((long) 16))) |
																				(((long) (BgL_v2z00_1215) <<
																						(int) (((long) 8))) |
																					(long) (BgL_v3z00_1216))));
																		{	/* Unsafe/sha2.scm 501 */

																			BGL_U32VSET(BgL_v32z00_1186,
																				BgL_iz00_1187, BgL_vz00_1217);
																			BUNSPEC;
																			return (BgL_jz00_1210 + ((long) 1));
												}}}}}}}
											else
												{	/* Unsafe/sha2.scm 494 */
													{	/* Unsafe/sha2.scm 505 */
														long BgL_arg1579z00_1223;

														{	/* Unsafe/sha2.scm 505 */
															long BgL_arg1580z00_1224;

															BgL_arg1580z00_1224 =
																(long)
																CINT(BGl_2zb2zb2zz__r4_numbers_6_5z00(BINT
																	(BgL_nz00_1189), BINT(BgL_jz00_1210)));
															{	/* Unsafe/sha2.scm 505 */
																unsigned char BgL_arg1557z00_3069;

																{	/* Unsafe/sha2.scm 505 */
																	long BgL_auxz00_5131;

																	BgL_auxz00_5131 =
																		LONG_TO_ELONG(BgL_arg1580z00_1224);
																	BgL_arg1557z00_3069 =
																		BGL_MMAP_REF(BgL_mmz00_1188,
																		BgL_auxz00_5131);
																}
																BgL_arg1579z00_1223 = (BgL_arg1557z00_3069);
														}}
														{	/* Unsafe/sha2.scm 505 */
															unsigned long BgL_auxz00_5135;

															BgL_auxz00_5135 =
																(unsigned long) (BgL_arg1579z00_1223);
															BGL_U32VSET(BgL_vz00_1207, BgL_jz00_1210,
																BgL_auxz00_5135);
														} BUNSPEC;
													}
													{
														long BgL_jz00_5138;

														BgL_jz00_5138 = (BgL_jz00_1210 + ((long) 1));
														BgL_jz00_1210 = BgL_jz00_5138;
														goto BgL_zc3anonymousza31572ze3z83_1211;
													}
												}
										}
									}
							}
					}
				}
			}
		}
	}



/* sha256sum-string */
	BGL_EXPORTED_DEF obj_t BGl_sha256sumzd2stringzd2zz__sha2z00(obj_t
		BgL_strz00_41)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 516 */
			{	/* Unsafe/sha2.scm 553 */
				obj_t BgL_statez00_1235;
				obj_t BgL_bufferz00_1236;

				BgL_statez00_1235 = BGl_sha256zd2initialzd2hashzd2valuezd2zz__sha2z00();
				{	/* Llib/srfi4.scm 236 */

					BgL_bufferz00_1236 =
						BGl_makezd2u32vectorzd2zz__srfi4z00(((long) 16), BINT(((long) 0)));
				}
				BGl_sha256zd2updatezd2zz__sha2z00(BgL_statez00_1235, BgL_bufferz00_1236,
					BgL_strz00_41, BGl_proc2506z00zz__sha2z00);
				return BGl_statezd2ze3stringz31zz__sha2z00(BgL_statez00_1235);
			}
		}
	}



/* &sha256sum-string */
	obj_t BGl_z62sha256sumzd2stringzb0zz__sha2z00(obj_t BgL_envz00_3519,
		obj_t BgL_strz00_3520)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 516 */
			{	/* Unsafe/sha2.scm 519 */
				obj_t BgL_auxz00_5147;

				if (STRINGP(BgL_strz00_3520))
					{	/* Unsafe/sha2.scm 519 */
						BgL_auxz00_5147 = BgL_strz00_3520;
					}
				else
					{
						obj_t BgL_auxz00_5150;

						BgL_auxz00_5150 =
							BGl_typezd2errorzd2zz__errorz00(BGl_string2503z00zz__sha2z00,
							BINT(((long) 21304)), BGl_string2507z00zz__sha2z00,
							BGl_string2508z00zz__sha2z00, BgL_strz00_3520);
						FAILURE(BgL_auxz00_5150, BFALSE, BFALSE);
					}
				return BGl_sha256sumzd2stringzd2zz__sha2z00(BgL_auxz00_5147);
			}
		}
	}



/* &fill-word32-string! */
	long BGl_z62fillzd2word32zd2stringz12z70zz__sha2z00(obj_t BgL_envz00_3521,
		obj_t BgL_v32z00_3522, obj_t BgL_iz00_3523, obj_t BgL_strz00_3524,
		obj_t BgL_nz00_3525)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 551 */
			{
				obj_t BgL_v32z00_1243;
				long BgL_iz00_1244;
				obj_t BgL_strz00_1245;
				long BgL_nz00_1246;

				BgL_v32z00_1243 = BgL_v32z00_3522;
				BgL_iz00_1244 = (long) CINT(BgL_iz00_3523);
				BgL_strz00_1245 = BgL_strz00_3524;
				BgL_nz00_1246 = (long) CINT(BgL_nz00_3525);
				{	/* Unsafe/sha2.scm 522 */
					long BgL_lz00_1248;

					BgL_lz00_1248 = STRING_LENGTH(BgL_strz00_1245);
					if (((BgL_nz00_1246 + ((long) 4)) <= BgL_lz00_1248))
						{	/* Unsafe/sha2.scm 525 */
							unsigned long BgL_v0z00_1250;

							BgL_v0z00_1250 =
								(unsigned long) ((STRING_REF(BgL_strz00_1245, BgL_nz00_1246)));
							{	/* Unsafe/sha2.scm 525 */
								unsigned long BgL_v1z00_1251;

								BgL_v1z00_1251 =
									(unsigned long) (
									(STRING_REF(BgL_strz00_1245, (BgL_nz00_1246 + ((long) 1)))));
								{	/* Unsafe/sha2.scm 526 */
									unsigned long BgL_v2z00_1252;

									BgL_v2z00_1252 =
										(unsigned long) (
										(STRING_REF(BgL_strz00_1245,
												(BgL_nz00_1246 + ((long) 2)))));
									{	/* Unsafe/sha2.scm 527 */
										unsigned long BgL_v3z00_1253;

										BgL_v3z00_1253 =
											(unsigned long) (
											(STRING_REF(BgL_strz00_1245,
													(BgL_nz00_1246 + ((long) 3)))));
										{	/* Unsafe/sha2.scm 528 */
											unsigned long BgL_vz00_1254;

											BgL_vz00_1254 =
												(unsigned long) (
												(((((long) (BgL_v0z00_1250) <<
																(int) (((long) 8))) |
															(long) (BgL_v1z00_1251)) <<
														(int) (((long) 16))) |
													(((long) (BgL_v2z00_1252) <<
															(int) (((long) 8))) | (long) (BgL_v3z00_1253))));
											{	/* Unsafe/sha2.scm 529 */

												BGL_U32VSET(BgL_v32z00_1243, BgL_iz00_1244,
													BgL_vz00_1254);
												BUNSPEC;
												return ((long) 4);
						}}}}}}
					else
						{	/* Unsafe/sha2.scm 524 */
							if ((BgL_nz00_1246 >= (((long) 1) + BgL_lz00_1248)))
								{	/* Unsafe/sha2.scm 532 */
									{	/* Unsafe/sha2.scm 533 */
										unsigned long BgL_auxz00_5192;

										BgL_auxz00_5192 = (unsigned long) (((long) 0));
										BGL_U32VSET(BgL_v32z00_1243, BgL_iz00_1244,
											BgL_auxz00_5192);
									} BUNSPEC;
									return ((long) 0);
								}
							else
								{	/* Unsafe/sha2.scm 536 */
									obj_t BgL_vz00_1264;
									long BgL_kz00_1265;

									BgL_vz00_1264 =
										BGl_makezd2u32vectorzd2zz__srfi4z00(((long) 4),
										BINT(((long) 0)));
									BgL_kz00_1265 =
										(((long) 4) -
										((BgL_nz00_1246 + ((long) 4)) - BgL_lz00_1248));
									{
										long BgL_jz00_1267;

										BgL_jz00_1267 = ((long) 0);
									BgL_zc3anonymousza31601ze3z83_1268:
										if ((BgL_jz00_1267 == BgL_kz00_1265))
											{	/* Unsafe/sha2.scm 539 */
												{	/* Unsafe/sha2.scm 541 */
													unsigned long BgL_auxz00_5202;

													BgL_auxz00_5202 = (unsigned long) (((long) 128));
													BGL_U32VSET(BgL_vz00_1264, BgL_jz00_1267,
														BgL_auxz00_5202);
												} BUNSPEC;
												{	/* Unsafe/sha2.scm 542 */
													unsigned long BgL_v0z00_1270;

													BgL_v0z00_1270 =
														BGL_U32VREF(BgL_vz00_1264, ((long) 0));
													{	/* Unsafe/sha2.scm 542 */
														unsigned long BgL_v1z00_1271;

														BgL_v1z00_1271 =
															BGL_U32VREF(BgL_vz00_1264, ((long) 1));
														{	/* Unsafe/sha2.scm 543 */
															unsigned long BgL_v2z00_1272;

															BgL_v2z00_1272 =
																BGL_U32VREF(BgL_vz00_1264, ((long) 2));
															{	/* Unsafe/sha2.scm 544 */
																unsigned long BgL_v3z00_1273;

																BgL_v3z00_1273 =
																	BGL_U32VREF(BgL_vz00_1264, ((long) 3));
																{	/* Unsafe/sha2.scm 545 */
																	unsigned long BgL_vz00_1274;

																	BgL_vz00_1274 =
																		(unsigned long) (
																		(((((long) (BgL_v0z00_1270) <<
																						(int) (((long) 8))) |
																					(long) (BgL_v1z00_1271)) <<
																				(int) (((long) 16))) |
																			(((long) (BgL_v2z00_1272) <<
																					(int) (((long) 8))) |
																				(long) (BgL_v3z00_1273))));
																	{	/* Unsafe/sha2.scm 546 */

																		BGL_U32VSET(BgL_v32z00_1243, BgL_iz00_1244,
																			BgL_vz00_1274);
																		BUNSPEC;
																		return (BgL_jz00_1267 + ((long) 1));
											}}}}}}}
										else
											{	/* Unsafe/sha2.scm 539 */
												{	/* Unsafe/sha2.scm 550 */
													long BgL_arg1611z00_1280;

													BgL_arg1611z00_1280 =
														(STRING_REF(BgL_strz00_1245,
															(long)
															CINT(BGl_2zb2zb2zz__r4_numbers_6_5z00(BINT
																	(BgL_nz00_1246), BINT(BgL_jz00_1267)))));
													{	/* Unsafe/sha2.scm 550 */
														unsigned long BgL_auxz00_5231;

														BgL_auxz00_5231 =
															(unsigned long) (BgL_arg1611z00_1280);
														BGL_U32VSET(BgL_vz00_1264, BgL_jz00_1267,
															BgL_auxz00_5231);
													} BUNSPEC;
												}
												{
													long BgL_jz00_5234;

													BgL_jz00_5234 = (BgL_jz00_1267 + ((long) 1));
													BgL_jz00_1267 = BgL_jz00_5234;
													goto BgL_zc3anonymousza31601ze3z83_1268;
												}
											}
									}
								}
						}
				}
			}
		}
	}



/* sha256sum-port */
	BGL_EXPORTED_DEF obj_t BGl_sha256sumzd2portzd2zz__sha2z00(obj_t BgL_pz00_42)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 561 */
			{	/* Unsafe/sha2.scm 563 */
				obj_t BgL_bufz00_1290;
				obj_t BgL_lenz00_1291;

				BgL_bufz00_1290 = MAKE_CELL(BUNSPEC);
				BgL_lenz00_1291 = MAKE_CELL(BUNSPEC);
				{	/* Unsafe/sha2.scm 569 */
					obj_t BgL_fillzd2word32zd2portz12z12_3526;

					{
						int BgL_auxz00_5238;

						BgL_auxz00_5238 = (int) (((long) 2));
						BgL_fillzd2word32zd2portz12z12_3526 =
							MAKE_L_PROCEDURE(BGl_z62fillzd2word32zd2portz12z70zz__sha2z00,
							BgL_auxz00_5238);
					}
					PROCEDURE_L_SET(BgL_fillzd2word32zd2portz12z12_3526,
						(int) (((long) 0)), BgL_bufz00_1290);
					PROCEDURE_L_SET(BgL_fillzd2word32zd2portz12z12_3526,
						(int) (((long) 1)), BgL_lenz00_1291);
					{	/* Unsafe/sha2.scm 563 */
						obj_t BgL_auxz00_3537;

						BgL_auxz00_3537 =
							BGl_makezd2u32vectorzd2zz__srfi4z00(((long) 4), BINT(((long) 0)));
						CELL_SET(BgL_bufz00_1290, BgL_auxz00_3537);
					}
					{	/* Unsafe/sha2.scm 616 */
						obj_t BgL_auxz00_3538;

						BgL_auxz00_3538 = BINT(((long) 0));
						CELL_SET(BgL_lenz00_1291, BgL_auxz00_3538);
					}
					{	/* Unsafe/sha2.scm 616 */
						obj_t BgL_statez00_1294;
						obj_t BgL_bufferz00_1295;

						BgL_statez00_1294 =
							BGl_sha256zd2initialzd2hashzd2valuezd2zz__sha2z00();
						{	/* Llib/srfi4.scm 236 */

							BgL_bufferz00_1295 =
								BGl_makezd2u32vectorzd2zz__srfi4z00(((long) 16),
								BINT(((long) 0)));
						}
						BGl_sha256zd2updatezd2zz__sha2z00(BgL_statez00_1294,
							BgL_bufferz00_1295, BgL_pz00_42,
							BgL_fillzd2word32zd2portz12z12_3526);
						return BGl_statezd2ze3stringz31zz__sha2z00(BgL_statez00_1294);
					}
				}
			}
		}
	}



/* &sha256sum-port */
	obj_t BGl_z62sha256sumzd2portzb0zz__sha2z00(obj_t BgL_envz00_3527,
		obj_t BgL_pz00_3528)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 561 */
			{	/* Unsafe/sha2.scm 563 */
				obj_t BgL_auxz00_5253;

				if (INPUT_PORTP(BgL_pz00_3528))
					{	/* Unsafe/sha2.scm 563 */
						BgL_auxz00_5253 = BgL_pz00_3528;
					}
				else
					{
						obj_t BgL_auxz00_5256;

						BgL_auxz00_5256 =
							BGl_typezd2errorzd2zz__errorz00(BGl_string2503z00zz__sha2z00,
							BINT(((long) 22771)), BGl_string2509z00zz__sha2z00,
							BGl_string2510z00zz__sha2z00, BgL_pz00_3528);
						FAILURE(BgL_auxz00_5256, BFALSE, BFALSE);
					}
				return BGl_sha256sumzd2portzd2zz__sha2z00(BgL_auxz00_5253);
			}
		}
	}



/* &fill-word32-port! */
	long BGl_z62fillzd2word32zd2portz12z70zz__sha2z00(obj_t BgL_envz00_3529,
		obj_t BgL_v32z00_3532, obj_t BgL_iz00_3533, obj_t BgL_pz00_3534,
		obj_t BgL_nz00_3535)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 614 */
			{	/* Unsafe/sha2.scm 584 */
				obj_t BgL_bufz00_3530;
				obj_t BgL_lenz00_3531;

				BgL_bufz00_3530 = PROCEDURE_L_REF(BgL_envz00_3529, (int) (((long) 0)));
				BgL_lenz00_3531 = PROCEDURE_L_REF(BgL_envz00_3529, (int) (((long) 1)));
				{
					obj_t BgL_v32z00_1314;
					long BgL_iz00_1315;
					obj_t BgL_pz00_1316;
					long BgL_nz00_1317;

					BgL_v32z00_1314 = BgL_v32z00_3532;
					BgL_iz00_1315 = (long) CINT(BgL_iz00_3533);
					BgL_pz00_1316 = BgL_pz00_3534;
					BgL_nz00_1317 = (long) CINT(BgL_nz00_3535);
					{
						obj_t BgL_pz00_1298;

						{	/* Unsafe/sha2.scm 584 */
							long BgL_lz00_1319;

							BgL_pz00_1298 = BgL_pz00_1316;
							{
								long BgL_iz00_1301;

								BgL_iz00_1301 = ((long) 0);
							BgL_zc3anonymousza31621ze3z83_1302:
								if ((BgL_iz00_1301 == ((long) 4)))
									{	/* Unsafe/sha2.scm 569 */
										BgL_lz00_1319 = BgL_iz00_1301;
									}
								else
									{	/* Unsafe/sha2.scm 571 */
										obj_t BgL_cz00_1304;

										BgL_cz00_1304 =
											BGl_readzd2bytezd2zz__r4_input_6_10_2z00(BgL_pz00_1298);
										{	/* Unsafe/sha2.scm 572 */
											bool_t BgL_testz00_5268;

											{	/* Unsafe/sha2.scm 572 */
												bool_t BgL_res2425z00_3202;

												BgL_res2425z00_3202 = EOF_OBJECTP(BgL_cz00_1304);
												BgL_testz00_5268 = BgL_res2425z00_3202;
											}
											if (BgL_testz00_5268)
												{
													long BgL_jz00_1307;

													BgL_jz00_1307 = BgL_iz00_1301;
												BgL_zc3anonymousza31624ze3z83_1308:
													if ((BgL_jz00_1307 == ((long) 4)))
														{	/* Unsafe/sha2.scm 574 */
															BgL_lz00_1319 = BgL_iz00_1301;
														}
													else
														{	/* Unsafe/sha2.scm 574 */
															{	/* Unsafe/sha2.scm 577 */
																unsigned long BgL_auxz00_5273;
																obj_t BgL_auxz00_5272;

																BgL_auxz00_5273 = (unsigned long) (((long) 0));
																BgL_auxz00_5272 = CELL_REF(BgL_bufz00_3530);
																BGL_U32VSET(BgL_auxz00_5272, BgL_jz00_1307,
																	BgL_auxz00_5273);
															} BUNSPEC;
															{
																long BgL_jz00_5276;

																BgL_jz00_5276 = (BgL_jz00_1307 + ((long) 1));
																BgL_jz00_1307 = BgL_jz00_5276;
																goto BgL_zc3anonymousza31624ze3z83_1308;
															}
														}
												}
											else
												{	/* Unsafe/sha2.scm 572 */
													{	/* Unsafe/sha2.scm 580 */
														unsigned long BgL_auxz00_5279;
														obj_t BgL_auxz00_5278;

														BgL_auxz00_5279 =
															(unsigned long) CINT(BgL_cz00_1304);
														BgL_auxz00_5278 = CELL_REF(BgL_bufz00_3530);
														BGL_U32VSET(BgL_auxz00_5278, BgL_iz00_1301,
															BgL_auxz00_5279);
													} BUNSPEC;
													{
														long BgL_iz00_5282;

														BgL_iz00_5282 = (BgL_iz00_1301 + ((long) 1));
														BgL_iz00_1301 = BgL_iz00_5282;
														goto BgL_zc3anonymousza31621ze3z83_1302;
													}
												}
										}
									}
							}
							{	/* Unsafe/sha2.scm 585 */
								obj_t BgL_auxz00_3536;

								BgL_auxz00_3536 =
									BINT(
									((long) CINT(CELL_REF(BgL_lenz00_3531)) + BgL_lz00_1319));
								CELL_SET(BgL_lenz00_3531, BgL_auxz00_3536);
							}
							if (
								((BgL_nz00_1317 + ((long) 4)) <=
									(long) CINT(CELL_REF(BgL_lenz00_3531))))
								{	/* Unsafe/sha2.scm 588 */
									unsigned long BgL_v0z00_1321;

									{	/* Unsafe/sha2.scm 588 */
										obj_t BgL_auxz00_5291;

										BgL_auxz00_5291 = CELL_REF(BgL_bufz00_3530);
										BgL_v0z00_1321 = BGL_U32VREF(BgL_auxz00_5291, ((long) 0));
									}
									{	/* Unsafe/sha2.scm 588 */
										unsigned long BgL_v1z00_1322;

										{	/* Unsafe/sha2.scm 589 */
											obj_t BgL_auxz00_5293;

											BgL_auxz00_5293 = CELL_REF(BgL_bufz00_3530);
											BgL_v1z00_1322 = BGL_U32VREF(BgL_auxz00_5293, ((long) 1));
										}
										{	/* Unsafe/sha2.scm 589 */
											unsigned long BgL_v2z00_1323;

											{	/* Unsafe/sha2.scm 590 */
												obj_t BgL_auxz00_5295;

												BgL_auxz00_5295 = CELL_REF(BgL_bufz00_3530);
												BgL_v2z00_1323 =
													BGL_U32VREF(BgL_auxz00_5295, ((long) 2));
											}
											{	/* Unsafe/sha2.scm 590 */
												unsigned long BgL_v3z00_1324;

												{	/* Unsafe/sha2.scm 591 */
													obj_t BgL_auxz00_5297;

													BgL_auxz00_5297 = CELL_REF(BgL_bufz00_3530);
													BgL_v3z00_1324 =
														BGL_U32VREF(BgL_auxz00_5297, ((long) 3));
												}
												{	/* Unsafe/sha2.scm 591 */
													unsigned long BgL_vz00_1325;

													BgL_vz00_1325 =
														(unsigned long) (
														(((((long) (BgL_v0z00_1321) <<
																		(int) (((long) 8))) |
																	(long) (BgL_v1z00_1322)) <<
																(int) (((long) 16))) |
															(((long) (BgL_v2z00_1323) <<
																	(int) (((long) 8))) |
																(long) (BgL_v3z00_1324))));
													{	/* Unsafe/sha2.scm 592 */

														BGL_U32VSET(BgL_v32z00_1314, BgL_iz00_1315,
															BgL_vz00_1325);
														BUNSPEC;
														return ((long) 4);
								}}}}}}
							else
								{	/* Unsafe/sha2.scm 587 */
									if (
										(BgL_nz00_1317 >=
											(((long) 1) + (long) CINT(CELL_REF(BgL_lenz00_3531)))))
										{	/* Unsafe/sha2.scm 595 */
											{	/* Unsafe/sha2.scm 596 */
												unsigned long BgL_auxz00_5318;

												BgL_auxz00_5318 = (unsigned long) (((long) 0));
												BGL_U32VSET(BgL_v32z00_1314, BgL_iz00_1315,
													BgL_auxz00_5318);
											} BUNSPEC;
											return ((long) 0);
										}
									else
										{	/* Unsafe/sha2.scm 599 */
											obj_t BgL_vz00_1332;
											long BgL_kz00_1333;

											BgL_vz00_1332 =
												BGl_makezd2u32vectorzd2zz__srfi4z00(((long) 4),
												BINT(((long) 0)));
											BgL_kz00_1333 =
												(((long) 4) -
												((BgL_nz00_1317 + ((long) 4)) -
													(long) CINT(CELL_REF(BgL_lenz00_3531))));
											{
												long BgL_jz00_1335;

												BgL_jz00_1335 = ((long) 0);
											BgL_zc3anonymousza31639ze3z83_1336:
												if ((BgL_jz00_1335 == BgL_kz00_1333))
													{	/* Unsafe/sha2.scm 602 */
														{	/* Unsafe/sha2.scm 604 */
															unsigned long BgL_auxz00_5329;

															BgL_auxz00_5329 = (unsigned long) (((long) 128));
															BGL_U32VSET(BgL_vz00_1332, BgL_jz00_1335,
																BgL_auxz00_5329);
														} BUNSPEC;
														{	/* Unsafe/sha2.scm 605 */
															unsigned long BgL_v0z00_1338;

															BgL_v0z00_1338 =
																BGL_U32VREF(BgL_vz00_1332, ((long) 0));
															{	/* Unsafe/sha2.scm 605 */
																unsigned long BgL_v1z00_1339;

																BgL_v1z00_1339 =
																	BGL_U32VREF(BgL_vz00_1332, ((long) 1));
																{	/* Unsafe/sha2.scm 606 */
																	unsigned long BgL_v2z00_1340;

																	BgL_v2z00_1340 =
																		BGL_U32VREF(BgL_vz00_1332, ((long) 2));
																	{	/* Unsafe/sha2.scm 607 */
																		unsigned long BgL_v3z00_1341;

																		BgL_v3z00_1341 =
																			BGL_U32VREF(BgL_vz00_1332, ((long) 3));
																		{	/* Unsafe/sha2.scm 608 */
																			unsigned long BgL_vz00_1342;

																			BgL_vz00_1342 =
																				(unsigned long) (
																				(((((long) (BgL_v0z00_1338) <<
																								(int) (((long) 8))) |
																							(long) (BgL_v1z00_1339)) <<
																						(int) (((long) 16))) |
																					(((long) (BgL_v2z00_1340) <<
																							(int) (((long) 8))) |
																						(long) (BgL_v3z00_1341))));
																			{	/* Unsafe/sha2.scm 609 */

																				BGL_U32VSET(BgL_v32z00_1314,
																					BgL_iz00_1315, BgL_vz00_1342);
																				BUNSPEC;
																				return (BgL_jz00_1335 + ((long) 1));
													}}}}}}}
												else
													{	/* Unsafe/sha2.scm 602 */
														{	/* Unsafe/sha2.scm 613 */
															unsigned long BgL_arg1647z00_1348;

															{	/* Unsafe/sha2.scm 613 */
																obj_t BgL_auxz00_5352;

																BgL_auxz00_5352 = CELL_REF(BgL_bufz00_3530);
																BgL_arg1647z00_1348 =
																	BGL_U32VREF(BgL_auxz00_5352, BgL_jz00_1335);
															}
															BGL_U32VSET(BgL_vz00_1332, BgL_jz00_1335,
																BgL_arg1647z00_1348);
															BUNSPEC;
														}
														{
															long BgL_jz00_5355;

															BgL_jz00_5355 = (BgL_jz00_1335 + ((long) 1));
															BgL_jz00_1335 = BgL_jz00_5355;
															goto BgL_zc3anonymousza31639ze3z83_1336;
														}
													}
											}
										}
								}
						}
					}
				}
			}
		}
	}



/* sha256sum-file */
	BGL_EXPORTED_DEF obj_t BGl_sha256sumzd2filezd2zz__sha2z00(obj_t
		BgL_fnamez00_43)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 624 */
			{	/* Unsafe/sha2.scm 625 */
				obj_t BgL_mmz00_1357;

				BgL_mmz00_1357 =
					BGl_openzd2mmapzd2zz__mmapz00(BgL_fnamez00_43, BTRUE, BFALSE);
				{	/* Unsafe/sha2.scm 626 */
					bool_t BgL_testz00_5360;

					{	/* Unsafe/sha2.scm 626 */
						bool_t BgL_res2452z00_3282;

						BgL_res2452z00_3282 = BGL_MMAPP(BgL_mmz00_1357);
						BgL_testz00_5360 = BgL_res2452z00_3282;
					}
					if (BgL_testz00_5360)
						{	/* Unsafe/sha2.scm 627 */
							obj_t BgL_val1059z00_1359;

							BgL_val1059z00_1359 =
								BGl_zc3exitza31658ze3z83zz__sha2z00(BgL_mmz00_1357);
							bgl_close_mmap(BgL_mmz00_1357);
							if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
									(BgL_val1059z00_1359)))
								{	/* Unsafe/sha2.scm 629 */
									return
										BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
										(BgL_val1059z00_1359), CDR(BgL_val1059z00_1359));
								}
							else
								{	/* Unsafe/sha2.scm 629 */
									return BgL_val1059z00_1359;
								}
						}
					else
						{	/* Unsafe/sha2.scm 630 */
							obj_t BgL_pz00_1366;

							{	/* Ieee/port.scm 382 */

								BgL_pz00_1366 =
									BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00
									(BgL_fnamez00_43, BTRUE, BINT(((long) 5000000)));
							}
							{	/* Unsafe/sha2.scm 631 */
								obj_t BgL_val1062z00_1367;

								BgL_val1062z00_1367 =
									BGl_zc3exitza31662ze3z83zz__sha2z00(BgL_pz00_1366);
								bgl_close_input_port(BgL_pz00_1366);
								if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
										(BgL_val1062z00_1367)))
									{	/* Unsafe/sha2.scm 633 */
										return
											BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
											(BgL_val1062z00_1367), CDR(BgL_val1062z00_1367));
									}
								else
									{	/* Unsafe/sha2.scm 633 */
										return BgL_val1062z00_1367;
									}
							}
						}
				}
			}
		}
	}



/* <exit:1662> */
	obj_t BGl_zc3exitza31662ze3z83zz__sha2z00(obj_t BgL_pz00_3546)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 633 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1063z00_1372;

			if (SET_EXIT(BgL_an_exit1063z00_1372))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1063z00_1372 = (void *) jmpbuf;
					{	/* Unsafe/sha2.scm 633 */

						PUSH_EXIT(BgL_an_exit1063z00_1372, ((long) 0));
						{	/* Unsafe/sha2.scm 632 */
							obj_t BgL_val1064z00_1373;

							BgL_val1064z00_1373 =
								BGl_sha256sumzd2portzd2zz__sha2z00(BgL_pz00_3546);
							POP_EXIT();
							return BgL_val1064z00_1373;
						}
					}
				}
		}
	}



/* <exit:1658> */
	obj_t BGl_zc3exitza31658ze3z83zz__sha2z00(obj_t BgL_mmz00_3547)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 629 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1060z00_1364;

			if (SET_EXIT(BgL_an_exit1060z00_1364))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1060z00_1364 = (void *) jmpbuf;
					{	/* Unsafe/sha2.scm 629 */

						PUSH_EXIT(BgL_an_exit1060z00_1364, ((long) 0));
						{	/* Unsafe/sha2.scm 628 */
							obj_t BgL_val1061z00_1365;

							BgL_val1061z00_1365 =
								BGl_sha256sumzd2mmapzd2zz__sha2z00(BgL_mmz00_3547);
							POP_EXIT();
							return BgL_val1061z00_1365;
						}
					}
				}
		}
	}



/* &sha256sum-file */
	obj_t BGl_z62sha256sumzd2filezb0zz__sha2z00(obj_t BgL_envz00_3539,
		obj_t BgL_fnamez00_3540)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 624 */
			{	/* Unsafe/sha2.scm 625 */
				obj_t BgL_auxz00_5390;

				if (STRINGP(BgL_fnamez00_3540))
					{	/* Unsafe/sha2.scm 625 */
						BgL_auxz00_5390 = BgL_fnamez00_3540;
					}
				else
					{
						obj_t BgL_auxz00_5393;

						BgL_auxz00_5393 =
							BGl_typezd2errorzd2zz__errorz00(BGl_string2503z00zz__sha2z00,
							BINT(((long) 24590)), BGl_string2511z00zz__sha2z00,
							BGl_string2508z00zz__sha2z00, BgL_fnamez00_3540);
						FAILURE(BgL_auxz00_5393, BFALSE, BFALSE);
					}
				return BGl_sha256sumzd2filezd2zz__sha2z00(BgL_auxz00_5390);
			}
		}
	}



/* sha256sum */
	BGL_EXPORTED_DEF obj_t BGl_sha256sumz00zz__sha2z00(obj_t BgL_objz00_44)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 638 */
			{	/* Unsafe/sha2.scm 640 */
				bool_t BgL_testz00_5398;

				{	/* Unsafe/sha2.scm 640 */
					bool_t BgL_res2453z00_3290;

					BgL_res2453z00_3290 = BGL_MMAPP(BgL_objz00_44);
					BgL_testz00_5398 = BgL_res2453z00_3290;
				}
				if (BgL_testz00_5398)
					{	/* Unsafe/sha2.scm 640 */
						return BGl_sha256sumzd2mmapzd2zz__sha2z00(BgL_objz00_44);
					}
				else
					{	/* Unsafe/sha2.scm 640 */
						if (STRINGP(BgL_objz00_44))
							{	/* Unsafe/sha2.scm 642 */
								return BGl_sha256sumzd2stringzd2zz__sha2z00(BgL_objz00_44);
							}
						else
							{	/* Unsafe/sha2.scm 642 */
								if (INPUT_PORTP(BgL_objz00_44))
									{	/* Unsafe/sha2.scm 644 */
										return BGl_sha256sumzd2portzd2zz__sha2z00(BgL_objz00_44);
									}
								else
									{	/* Unsafe/sha2.scm 644 */
										return
											BGl_errorz00zz__errorz00(BGl_string2512z00zz__sha2z00,
											BGl_string2513z00zz__sha2z00, BgL_objz00_44);
									}
							}
					}
			}
		}
	}



/* &sha256sum */
	obj_t BGl_z62sha256sumz62zz__sha2z00(obj_t BgL_envz00_3541,
		obj_t BgL_objz00_3542)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 638 */
			return BGl_sha256sumz00zz__sha2z00(BgL_objz00_3542);
		}
	}



/* hmac-sha256sum-string */
	BGL_EXPORTED_DEF obj_t BGl_hmaczd2sha256sumzd2stringz00zz__sha2z00(obj_t
		BgL_keyz00_45, obj_t BgL_msgz00_46)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 652 */
			return
				BGl_hmaczd2stringzd2zz__hmacz00(BgL_keyz00_45, BgL_msgz00_46,
				BGl_sha256sumzd2stringzd2envz00zz__sha2z00);
		}
	}



/* &hmac-sha256sum-string */
	obj_t BGl_z62hmaczd2sha256sumzd2stringz62zz__sha2z00(obj_t BgL_envz00_3543,
		obj_t BgL_keyz00_3544, obj_t BgL_msgz00_3545)
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 652 */
			{	/* Unsafe/sha2.scm 653 */
				obj_t BgL_auxz00_5417;
				obj_t BgL_auxz00_5410;

				if (STRINGP(BgL_msgz00_3545))
					{	/* Unsafe/sha2.scm 653 */
						BgL_auxz00_5417 = BgL_msgz00_3545;
					}
				else
					{
						obj_t BgL_auxz00_5420;

						BgL_auxz00_5420 =
							BGl_typezd2errorzd2zz__errorz00(BGl_string2503z00zz__sha2z00,
							BINT(((long) 25569)), BGl_string2514z00zz__sha2z00,
							BGl_string2508z00zz__sha2z00, BgL_msgz00_3545);
						FAILURE(BgL_auxz00_5420, BFALSE, BFALSE);
					}
				if (STRINGP(BgL_keyz00_3544))
					{	/* Unsafe/sha2.scm 653 */
						BgL_auxz00_5410 = BgL_keyz00_3544;
					}
				else
					{
						obj_t BgL_auxz00_5413;

						BgL_auxz00_5413 =
							BGl_typezd2errorzd2zz__errorz00(BGl_string2503z00zz__sha2z00,
							BINT(((long) 25569)), BGl_string2514z00zz__sha2z00,
							BGl_string2508z00zz__sha2z00, BgL_keyz00_3544);
						FAILURE(BgL_auxz00_5413, BFALSE, BFALSE);
					}
				return
					BGl_hmaczd2sha256sumzd2stringz00zz__sha2z00(BgL_auxz00_5410,
					BgL_auxz00_5417);
			}
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__sha2z00()
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 50 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__sha2z00()
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 50 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__sha2z00()
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 50 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__sha2z00()
	{
		AN_OBJECT;
		{	/* Unsafe/sha2.scm 50 */
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 441709255),
				BSTRING_TO_STRING(BGl_string2515z00zz__sha2z00));
			return
				BGl_modulezd2initializa7ationz75zz__hmacz00(((long) 285132844),
				BSTRING_TO_STRING(BGl_string2515z00zz__sha2z00));
		}
	}

#ifdef __cplusplus
}
#endif
